#include "type.h"

type_method_table* findMethodName( type_class* class, u1* name, u1* descriptor )
{
	type_method_table* methods;
	u4	nmethod;
	u4	i;
	int	inheritance = 0;

//	if ( class == 0 )
//		class = cload( interUTF8new("java/lang/Class") );
	
	for( ; class != 0 ; class = class->super )
	{
		methods = class->methods;
		nmethod = class->nmethod;

//		printf("   (class %s) %s %s\n", class->name, name, descriptor );
	
		for( i = 0 ; i < nmethod ; i++ )
		{
//			printf("\t%s %s ? %s %s \n",
//				methods[i].name, methods[i].descriptor,
//				name, descriptor );
			
			if( (methods[i].name == name) &&
				(methods[i].descriptor == descriptor) )
			{
				if( inheritance && methods[i].flag&ACC_PRIVATE )
				{
					return (0);
				}
				else
				{
					return (&methods[i]);
				}
			}
		}
		inheritance = 1;
	}

	return (0);
}


// ============================================================================
//
// ============================================================================

type_method_table* findInheritedMethod( type_method_table* method, type_frame* frame )
{
	type_object* object;
	type_method_table* inheritance;
	type_class* class;

	object = *(frame->tos-method->parsize+1);

//	if( *(u4*)object == 0 )
//		class = cload( interUTF8new("java/lang/Class"), 0 );
//	else
//		class = object->cls;
	
	inheritance = findMethodName( object->cls, method->name, method->descriptor );
	if( inheritance == 0 )
	{
		printf("findInheritedMethod error %x %s : %s %s %s (%x)\n", object,
			       	((type_class*)object->cls)->name,
				((type_class*)method->cls)->name,
				method->name, method->descriptor,
		     		method->code );
		exit(0);
	}

	return (inheritance);
}


// ============================================================================
//
// ============================================================================


type_method_table* findInterfaceMethodName(type_class* class,u1* name,u1* descriptor)
{
	type_method_table* methods;
	u4	nmethod;
	u4	i,j;


	methods = class->methods;
	nmethod = class->nmethod;

//	printf("   (class %s) %s %s\n", class->name, name, descriptor );

	for( i = 0 ; i < nmethod ; i++ )
	{
//		printf("\t%s %s ? %s %s \n",
//			methods[i].name, methods[i].descriptor,
//			name, descriptor );
			
		if( (methods[i].name == name) &&
			(methods[i].descriptor == descriptor) )
			return (&methods[i]);
	}

	for( i = 0 ; i < class->ninterface ; i++ )
	{
		if( ( methods = findInterfaceMethodName(
			class->interfaces[i], name, descriptor ) ) != 0 )
			return (methods);
	}

	return (0);
}


type_field* findFieldName( type_class* class, u1* name, u1* descriptor )
{
	type_field* fields;
	u4	nfield;
	u4	i;


	for( ; class != 0 ; class = class->super )
	{
		fields = class->fields;
		nfield = class->nfield;

//		printf("\t(class %s)\n", class->name );

		for( i = 0 ; i < nfield ; i++ )
		{
//			printf("\t%s %s ? %s %s \n",
//				fields[i].name, fields[i].descriptor,
//				name, descriptor );
			if( fields[i].name == name &&
				fields[i].descriptor == descriptor )
				return (&fields[i]);	
		}
	}
	
	return (0);
}
