#include "gc.h"
#include "thread.h"

PBO_MODULE(gc);

pbo_t* gc_pbo;

pbo_t* get_gc( void )
{
	pbo_t * pbo = (pbo_t*)malloc( sizeof(pbo_t) );
	pbo->func = (pboFunc_t*)&gcFunc;
	pbo->local = (void*)malloc( sizeof(gc_t) );

	printf( "[GC] get gc : pbo {%x} / func {%x} / local {%x}\n",
			pbo, pbo->func, pbo->local );
	
	return (pbo);
}


int gcInit( pbo_t* pbo )
{
	gc_pbo = pbo;
	gc_t* local = pbo->local;
	*local->gc_thread = pbo->thread;
	
	/* test */
	utf8Init();
	jinit( sizeof(0x100) );

	printf("[GC] init\n");

	return (int)pbo;
}


int gcCycle( gc_t* local )
{
	int state;
	char* str;
	int size;
	void* mem;
	unsigned int temp;


	switch( *local->state )
	{
	case 1:	// allocate memory

		size = *local->data_global;
		mem = jmalloc( size );
		*local->data_local = mem;
 		break;
		
	case 2: // allocate utf8

		exit(0);
		str = *local->data_global;
		str = utf8New( str );
		*local->data_local = str;
		break;

	default:

//		exit(0);
		break;
	}

	printf("[GC] one cycle\n");

//	pthread_mutex_lock( local->signal_global );	
//	pthread_cond_signal( *local->signal );

	return (local);
}

int gcTerm( gc_t* local )
{	
	return (int)local;
}
