#ifndef __hash_h
#define __hash_h

struct _hashtab;
typedef struct _hashtab *hash_t;

typedef int	(*pf_hash)(const void *ptr1);
typedef int	(*pf_comp)(const void *ptr1, const void *ptr2);
typedef void*	(*pf_alloc)(int);
typedef void	(*pf_free)(const void *ptr);

extern hash_t	hashInit(pf_hash,pf_comp,pf_alloc,pf_free);
extern void*	hashAdd(hash_t, const void*);
extern void	hashRemove(hash_t, const void*);
extern void*	hashFind(hash_t, const void*);
extern void	hashFinal(hash_t);

#endif
