/* $Log: inflate.h,v $
/* Revision 1.1.1.1  2004/08/05 01:48:27  numenor
/*
/*
/* Revision 1.1.1.1  2004/07/22 22:50:07  numenor
/*
/*
/* Revision 1.1.1.1  2004/02/24 07:19:36  nataxia
/* cream project
/*
/* Revision 1.2  2002/07/30 06:07:55  nataxia
/* fix some memory bugs
/*
/*
*/

/*
 * inflate.h
 * JAR inflater.
 *
 * This is a heavily hacked version of Mark Adler's inflater taken from the
 * public domina UNZIP sources, version c15c, 28 March 1997.
 *
 * Copyright (c) 1996, 1997
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 */

#ifndef __inflate_h
#define __inflate_h

//#include "../typendata/data_structure.h"

typedef unsigned char	uint8;
typedef unsigned short	uint16;
typedef unsigned int	uint32;
typedef unsigned long	uint64;

struct _huft;

typedef struct _inflateInfo {
	uint8*		slide;
	unsigned 	hufts;		/* track memory usage */
	struct _huft*	fixed_tl;
	struct _huft*	fixed_td;
	int		fixed_bl;
	int		fixed_bd;
	unsigned	wp;		/* current position in slide */
	uint32		bb;		/* bit buffer */
	unsigned	bk;		/* bits in bit buffer */
	uint8*		inbuf;
	int		insz;
	uint8*		outbuf;
	int		outsz;
} inflateInfo;

extern inflateInfo* inflate_new(void);
extern int inflate_free(inflateInfo*);
extern int inflate_oneshot(uint8*, int, uint8*, int);

#endif
