#ifndef __inst_h
#define __inst_h
/*
#include "./execute.h"
#include "../typendata/data_structure.h"
#include "../typendata/jtypes.h"
#include "../typendata/macros.h"
#include "../typendata/arrays.h"
#include "../loader/loader.h"
#include "../loader/field.h"
#include "../exception/exception.h"
#include "../execution/call.h"
#include "../thread/lock.h"
*/

#include "type.h"
#include "jtypes.h"

// macro : added by genee

// 32bit shift
#define c_ntohl(x)	((x + 0 << 24) | (x + 1 << 16) | (x + 2 << 8) | (x + 3))

// type casting macro 
#define inst_x_to_y(src_type, dest_type)			\
{								\
*(dest_type *)execute_data->tos = *(src_type *)execute_data->tos;\
}

const u1 insnLen[256] = {
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
	2, 3, 2, 3, 3, 2, 2, 2, 2, 2, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 1, 3, 3, 3, 3, 3, 3, 3, 
	3, 3, 3, 3, 3, 3, 3, 3, 3, 2, 1, 1, 0, 0, 0, 0, 
	0, 0, 3, 3, 3, 3, 3, 3, 3, 5, 1, 3, 2, 3, 1, 1, 
	3, 3, 1, 1, 1, 4, 3, 3, 5, 5, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
};

// NOTE :
// Java stack frame(the local variables and operend stack) is
// defined in terms of words.
// The word size must be large enought to hold a value of all
// types except long ad double(they take 2-word size).


#define push(v)			\
	(frame->tos)++;		\
	*(frame->tos) = v;	\

#define pop(t)			\
	*(t*)(frame->tos)--	\


// new

#define PUSH(v,t)		\
	(frame->tos)++;		\
	*(t*)(frame->tos) = v	\

#define POP(t)			\
	*(t*)(frame->tos)--	\

// if you want to changed ordering stack, you changes constant read of loader read.c
 
#define GET_DOUBLESIZE(val)	\
{	u4* tmp = (u4*)&val;	\
	tmp[1] = POP(u4);	\
	tmp[0] = POP(u4);}	\

#define SET_DOUBLESIZE(val)	\
{	u4* tmp = (u4*)&val;	\
	PUSH( tmp[0], u4 );	\
	PUSH( tmp[1], u4 );}	\

#define POP_DOUBLESIZE(ref)	\
{	*(ref+1) = POP(u4);	\
	*(ref+0) = POP(u4);}	\

#define PUSH_DOUBLESIZE(ref)	\
{	PUSH( *(ref+0), u4 );	\
	PUSH( *(ref+1), u4 );}	\

// byte code instructions.

void inst_nop()
{
}

void inst_aconst_null( type_frame* frame )
{
	push(0);
}

void inst_iconst_m1( type_frame* frame )
{
	push(-1);
}

void inst_iconst_0( type_frame* frame )
{
	push(0);
}

void inst_iconst_1( type_frame* frame )
{
	push(1);
}

void inst_iconst_2( type_frame* frame )
{
	push(2);
}

void inst_iconst_3( type_frame* frame )
{
	push(3);
}

void inst_iconst_4( type_frame* frame )
{
	push(4);
}

void inst_iconst_5( type_frame* frame )
{
	push(5);
}

void inst_lconst_0( type_frame* frame )
{
	jlong val = 0;
	SET_DOUBLESIZE(val);
}

void inst_lconst_1( type_frame* frame )
{
	jlong val = 1;
	SET_DOUBLESIZE(val);
}

void inst_fconst_0( type_frame* frame )
{
	(frame->tos)++;
	*(float*)(frame->tos) = 0.0f;
}

void inst_fconst_1( type_frame* frame )
{
	(frame->tos)++;
	*(float*)(frame->tos) = 1.0f;
}

void inst_fconst_2( type_frame* frame )
{
	(frame->tos)++;
	*(float*)(frame->tos) = 2.0f;
}

void inst_dconst_0( type_frame* frame )
{
	jdouble val = 0;
	SET_DOUBLESIZE(val);
}

void inst_dconst_1( type_frame* frame )
{
	jdouble val = 1;
	SET_DOUBLESIZE(val);
}

void inst_bipush( type_frame* frame )
{
	signed char bi = frame->pc[1];
	signed int val = bi;
	push( val );
}

void inst_sipush( type_frame* frame )
{
	u1* buf = frame->pc;
	signed short si = ((buf[1] << 8) | (buf[2]));
	signed int val = si;
	push( val );
}

// constant operations

void inst_ldc( type_frame* frame )
{
	type_constant* pool = (type_constant*)frame->pool;
	u1 index = ( frame->pc[1] );

	if( IS_RESOLVED(pool,index) )
	{
		PUSH( (pool->data)[index], u4 );
	}
	else
	{
		printf( " x unknown %x\n", (pool->tag)[index] );
		exit(0);
	}
}

void inst_ldc_w( type_frame* frame )
{
	type_constant* pool = (type_constant*)frame->pool;
	u2 index = ( frame->pc[1] ) << 8 | frame->pc[2] ;

	if( IS_RESOLVED( pool, index ) )
	{
		PUSH( (pool->data)[index], u4 );
	}
	else
	{
		printf( " x unknown %x\n", (pool->tag)[index] );
		exit(0);
	}
}

// index1[4,5,6,7] index2[0,1,2,3]
void inst_ldc2_w( type_frame* frame )
{
	type_constant* pool = frame->pool;
	u2 index = ( frame->pc[1] ) << 8 | frame->pc[2] ;

	PUSH( pool->data[index+1], u4 );
	PUSH( pool->data[index], u4 );
}

// load operations

void inst_iload( type_frame* frame )
{
	u1 idx = frame->pc[1];
	push( frame->local[idx] );
}

void inst_lload( type_frame* frame )
{
	u1 idx = frame->pc[1];
	PUSH_DOUBLESIZE( &frame->local[idx] );
}
/*
void inst_fload( type_frame* frame )
{
	u1 idx = frame->pc[1];
	push( frame->local[idx] );
}

void inst_dload( type_frame* frame )
{
	u1 idx = frame->pc[1];
	PUSH_DOUBLESIZE( &frame->local[idx] );
}

void inst_aload( type_frame* frame )
{
	u1 idx = frame->pc[1];
	push( frame->local[idx] );
}
*/
void inst_iload_0( type_frame* frame )
{
	push( frame->local[0] );
}

void inst_iload_1( type_frame* frame )
{
	push( frame->local[1] );
}

void inst_iload_2( type_frame* frame )
{
	push( frame->local[2] );
}

void inst_iload_3( type_frame* frame )
{
	push( frame->local[3]);
}

void inst_lload_0( type_frame* frame )
{
	PUSH_DOUBLESIZE( &frame->local[0] );
}

void inst_lload_1( type_frame* frame )
{
	PUSH_DOUBLESIZE( &frame->local[1] );
}

void inst_lload_2( type_frame* frame )
{
	PUSH_DOUBLESIZE( &frame->local[2] );
}

void inst_lload_3( type_frame* frame )
{
	PUSH_DOUBLESIZE( &frame->local[3] );
}
/*
void inst_fload_0()
{
	runnable* execute_data = gTT()->frame;
	push(execute_data->local[0]);
}

void inst_fload_1()
{
	runnable* execute_data = gTT()->frame;
	push(execute_data->local[1]);
}

void inst_fload_2()
{
	runnable* execute_data = gTT()->frame;
	push(execute_data->local[2]);
}

void inst_fload_3()
{
	runnable* execute_data = gTT()->frame;
	push(execute_data->local[3]);
}

void inst_dload_0()
{
	runnable* execute_data = gTT()->frame;
	PUSH_DOUBLESIZE( &execute_data->local[0] );
}

void inst_dload_1()
{
	runnable* execute_data = gTT()->frame;
	PUSH_DOUBLESIZE( &execute_data->local[1] );
}

void inst_dload_2()
{
	runnable* execute_data = gTT()->frame;
	PUSH_DOUBLESIZE( &execute_data->local[2] );
}

void inst_dload_3()
{
	runnable* execute_data = gTT()->frame;
	PUSH_DOUBLESIZE( &execute_data->local[3] );
}

void inst_aload_0()
{
	runnable* execute_data = gTT()->frame;
	push(execute_data->local[0]);
}

void inst_aload_1()
{
	runnable* execute_data = gTT()->frame;
	push(execute_data->local[1]);
}

void inst_aload_2()
{
	runnable* execute_data = gTT()->frame;
	push(execute_data->local[2]);
}

void inst_aload_3()
{
	runnable* execute_data = gTT()->frame;
	push(execute_data->local[3]);
}
*/

// array load operations

void inst_iaload( type_frame* frame )
{
	unsigned int index = pop(u4);
	type_array* array = pop(u4);
	jint value = ((jint*)array->ref)[index];
	push(value);
}

void inst_laload( type_frame* frame )
{
	unsigned int index = pop(u4);
	type_array* array = pop(u4);
	jlong value = ((jlong*)array->ref)[index];
	SET_DOUBLESIZE(value);
}

void inst_faload( type_frame* frame )
{
	unsigned int index = pop(u4);
	type_array* array = pop(u4);
	jfloat value = ((jfloat*)array->ref)[index];
	push(value);
}

void inst_daload( type_frame* frame )
{
	unsigned int index = pop(u4);
	type_array* array = pop(u4);
	jdouble value = ((jdouble*)array->ref)[index];
	SET_DOUBLESIZE(value);
}

void inst_aaload( type_frame* frame )
{
	unsigned int index = POP(u4);
	type_array* array = POP(u4);

	jobject value = ((jobject*)array->ref)[index];
	PUSH( value, u4 );
}

void inst_baload( type_frame* frame )
{
	unsigned int index = pop(u4);
	type_array* array = pop(u4);
	jbyte value = ((jbyte*)array->ref)[index] & 0xff;
	push(value);
}

void inst_caload( type_frame* frame )
{
	unsigned int index = pop(u4);
	type_array* array = pop(u4);
	jchar value = ((jchar*)array->ref)[index] & 0xffff;
	push(value);
}

void inst_saload( type_frame* frame )
{
	unsigned int index = pop(u4);
	type_array* array = pop(u4);
	jshort value = ((jshort*)array->ref)[index] & 0xffff;
	push(value);
}

// store operations

void inst_istore( type_frame* frame )
{
	frame->local[ frame->pc[1] ] = pop(u4);
}

void inst_lstore( type_frame* frame )
{
	u1 idx = frame->pc[1];
	POP_DOUBLESIZE( &frame->local[idx] );
}
/*
void inst_fstore( type_frame* frame )
{
	frame->local[ frame->pc[1] ] = pop(u4);
}

void inst_dstore( type_frame* frame )
{
	u1 idx = frame->pc[1];
	POP_DOUBLESIZE( &frame->local[idx] );
}

void inst_astore( type_frame* frame )
{
	frame->local[ frame->pc[1] ] = pop(u4);
}
*/
void inst_istore_0( type_frame* frame )
{
	frame->local[0] = pop(u4);
}

void inst_istore_1( type_frame* frame )
{
	frame->local[1] = pop(u4);
}

void inst_istore_2( type_frame* frame )
{
	frame->local[2] = pop(u4);
}

void inst_istore_3( type_frame* frame )
{
	frame->local[3] = pop(u4);
}

void inst_lstore_0( type_frame* frame )
{
	POP_DOUBLESIZE( &frame->local[0] );
}

void inst_lstore_1( type_frame* frame )
{
	POP_DOUBLESIZE( &frame->local[1] );
}

void inst_lstore_2( type_frame* frame )
{
	POP_DOUBLESIZE( &frame->local[2] );
}

void inst_lstore_3( type_frame* frame )
{
	POP_DOUBLESIZE( &frame->local[3] );
}

/*
void inst_fstore_0( type_frame* frame )
{
	pop( frame->local[0] );
}

void inst_fstore_1( type_frame* frame )
{
	pop( frame->local[1] );
}

void inst_fstore_2( type_frame* frame )
{
	pop( frame->local[2] );
}

void inst_fstore_3()
{
	runnable* execute_data = gTT()->frame;
	execute_data->local[3] = pop();
}

void inst_dstore_0()
{
	runnable* execute_data = gTT()->frame;
	POP_DOUBLESIZE( &execute_data->local[0] );
}

void inst_dstore_1()
{
	runnable* execute_data = gTT()->frame;
	POP_DOUBLESIZE( &execute_data->local[1] );
}

void inst_dstore_2()
{
	runnable* execute_data = gTT()->frame;
	POP_DOUBLESIZE( &execute_data->local[2] );
}

void inst_dstore_3()
{
	runnable* execute_data = gTT()->frame;
	POP_DOUBLESIZE( &execute_data->local[3] );
}

void inst_astore_0()
{
	runnable* execute_data = gTT()->frame;
	execute_data->local[0] = pop();
}

void inst_astore_1()
{
	runnable* execute_data = gTT()->frame;
	execute_data->local[1] = pop();
}

void inst_astore_2()
{
	runnable* execute_data = gTT()->frame;
	execute_data->local[2] = pop();
}

void inst_astore_3()
{
	runnable* execute_data = gTT()->frame;
	execute_data->local[3] = pop();
}
*/

void inst_iastore( type_frame* frame )
{
	jint value = pop(u4);
	unsigned int index = pop(u4);
	type_array* array = pop(u4);
	((jint*)array->ref)[index] = value;
}

void inst_lastore( type_frame* frame )
{
	jlong value;
	unsigned int index;
	type_array* array;

	GET_DOUBLESIZE(value);
	index = pop(u4);
	array = pop(u4);
	((jlong*)array->ref)[index] = value;
}

void inst_fastore( type_frame* frame )
{
	jfloat value = pop(u4);
	unsigned int index = pop(u4);
	type_array* array = pop(u4);
	((jfloat*)array->ref)[index] = value;
}

void inst_dastore( type_frame* frame )
{
	jdouble value;
	unsigned int index;
	type_array* array;

	GET_DOUBLESIZE(value);
	index = pop(u4);
	array = pop(u4);
	((jdouble*)array->ref)[index] = value;
}

void inst_aastore( type_frame* frame )
{
	jobject value = pop(u4);
	unsigned int index = pop(u4);
	type_array* array = pop(u4);
	((jobject*)array->ref)[index] = value;
}

void inst_bastore( type_frame* frame )
{
	jbyte value = pop(u4) & 0xff;
	unsigned int index = pop(u4);
	type_array* array = pop(u4);
	((jbyte*)array->ref)[index] = value;
}

void inst_castore( type_frame* frame )
{
	jchar value = pop(u4) & 0xffff;
	unsigned int index = pop(u4);
	type_array* array = pop(u4);
	((jchar*)array->ref)[index] = value;
}

void inst_sastore( type_frame* frame )
{
	jshort value = pop(u4) & 0xffff;
	unsigned int index = pop(u4);
	type_array* array = pop(u4);
	((jshort*)array->ref)[index] = value;
}

void inst_pop( type_frame* frame )
{
	(frame->tos)--;
}

void inst_pop2( type_frame* frame )
{
	(frame->tos)-=2;
}

void inst_dup( type_frame* frame )
{
	(frame->tos)++;
	(*frame->tos) = *(frame->tos-1);
}

void inst_dup_x1( type_frame* frame )
{
	(frame->tos)++;
	*(frame->tos) = *(frame->tos-1);
	*(frame->tos-1) = *(frame->tos-2);
	*(frame->tos-2) = *(frame->tos);
}

void inst_dup_x2( type_frame* frame )
{
	(frame->tos)++;
	*(frame->tos) = *(frame->tos-1);
	*(frame->tos-1) = *(frame->tos-2);
	*(frame->tos-2) = *(frame->tos-3);
	*(frame->tos-3) = *(frame->tos);
}

void inst_dup2( type_frame* frame )
{
	(frame->tos)+=2;
	*(frame->tos) = *(frame->tos-2);
	*(frame->tos-1) = *(frame->tos-3);
}

void inst_dup2_x1( type_frame* frame )
{
	(frame->tos)+=2;
	*(frame->tos) = *(frame->tos-2);
	*(frame->tos-1) = *(frame->tos-3);
	*(frame->tos-2) = *(frame->tos-4);
	*(frame->tos-3) = *(frame->tos);
	*(frame->tos-4) = *(frame->tos-1);
}

void inst_dup2_x2( type_frame* frame )
{
	(frame->tos)+=2;
	*(frame->tos) = *(frame->tos-2);
	*(frame->tos-1) = *(frame->tos-3);
	*(frame->tos-2) = *(frame->tos-4);
	*(frame->tos-3) = *(frame->tos-5);
	*(frame->tos-4) = *(frame->tos);
	*(frame->tos-5) = *(frame->tos-2);
}

void inst_swap( type_frame* frame )
{
	u4 tmp = *(frame->tos-1);
	*(frame->tos-1) = *(frame->tos);
	*(frame->tos) = tmp;
}

// arithmetic

void inst_iadd( type_frame* frame )
{
	(frame->tos)--;
	*(jint*)(frame->tos) += *(jint*)(frame->tos+1);
}

void inst_ladd( type_frame* frame )
{
	jlong val1;
	jlong val2;

	GET_DOUBLESIZE(val2);
	GET_DOUBLESIZE(val1);
	val1 += val2;
	SET_DOUBLESIZE(val1);
}

void inst_fadd( type_frame* frame )
{
	exit(0);
	(frame->tos)--;
	*(jfloat*)(frame->tos) += *(jfloat*)(frame->tos+1);
}

void inst_dadd( type_frame* frame )
{
	exit(0);
	jdouble val1;
	jdouble val2;

	GET_DOUBLESIZE(val2);
	GET_DOUBLESIZE(val1);
	val1 += val2;
	SET_DOUBLESIZE(val1);
}

void inst_isub( type_frame* frame )
{
	(frame->tos)--;
	*(jint*)(frame->tos) -= *(jint*)(frame->tos+1);
}

void inst_lsub( type_frame* frame )
{
	jlong val1;
	jlong val2;
	
	GET_DOUBLESIZE(val2);
	GET_DOUBLESIZE(val1);
	val1 -= val2;
	SET_DOUBLESIZE(val1);
}

void inst_fsub( type_frame* frame )
{
	exit(0);
	(frame->tos)--;
	*(jfloat*)(frame->tos) -= *(jfloat*)(frame->tos+1);
}

void inst_dsub( type_frame* frame )
{
	exit(0);
	jdouble val1;
	jdouble val2;
	
	GET_DOUBLESIZE(val2);
	GET_DOUBLESIZE(val1);
	val1 -= val2;
	SET_DOUBLESIZE(val1);
}

void inst_imul( type_frame* frame )
{
	(frame->tos)--;
	*(jint*)(frame->tos) *= *(jint*)(frame->tos+1);
}

void inst_lmul( type_frame* frame )
{
	jlong val1;
	jlong val2;

	GET_DOUBLESIZE(val2);
	GET_DOUBLESIZE(val1);
	val1 *= val2;
	SET_DOUBLESIZE(val1);
}

void inst_fmul( type_frame* frame )
{
	jfloat val2 = POP(jfloat);
	jfloat val1 = POP(jfloat);
	val1 *= val2;
	PUSH( val1, jfloat );
}

void inst_dmul( type_frame* frame )
{
	exit(0);
	jdouble val1;
	jdouble val2;
	
	GET_DOUBLESIZE(val2);
	GET_DOUBLESIZE(val1);
	val1 *= val2;
	SET_DOUBLESIZE(val1);
}

void inst_idiv( type_frame* frame )
{
	jint r = POP(jint);
	jint l = POP(jint);

	// is the int div int a int?
	if ( r == 0 )
	{	exit(0);
//		handleArithmeticException;
	}
	else if ( l == 0 )
	{	PUSH(l,jint); }
	else
	{	PUSH(l/r,jint);	}
}

void inst_ldiv( type_frame* frame )
{
	jlong val1;
	jlong val2;
	
	GET_DOUBLESIZE(val2);
	GET_DOUBLESIZE(val1);
	val1 /= val2;
	SET_DOUBLESIZE(val1);
}

void inst_fdiv( type_frame* frame )
{
	exit(0);
	jfloat r = pop(jfloat);
	jfloat l = pop(jfloat);

	if ( r == 0 )
	{
//		handleArithmeticException;
	}
	else if ( l == 0 )
	{
		push( l );
	}
	else
	{
		push( l / r );
	}
}

void inst_ddiv( type_frame* frame )
{
	exit(0);
	jdouble val1;
	jdouble val2;
	
	GET_DOUBLESIZE(val2);
	GET_DOUBLESIZE(val1);
	val1 /= val2;
	SET_DOUBLESIZE(val1);
}

void inst_irem( type_frame* frame )
{
	jint v2 = POP(jint);
	jint v1 = POP(jint);
	jint result = v1 - ( v1 / v2 ) * v2;
	PUSH( result, jint );
}

void inst_lrem( type_frame* frame )
{
	jlong v1;
	jlong v2;
	jlong result = 0;
	GET_DOUBLESIZE(v2);
	GET_DOUBLESIZE(v1);
	result = v1 - ( v1 / v2 ) * v2;
	SET_DOUBLESIZE(result);
}

void inst_frem( type_frame* frame )
{
	exit(0);
	jfloat rvalue = pop(jfloat);
	jfloat lvalue = pop(jfloat);
	jfloat result;
	result = lvalue - ((jint)(lvalue / rvalue) * rvalue);
	push( result );
}

void inst_drem( type_frame* frame )
{
	exit(0);
	jdouble v1;
	jdouble v2;
	jdouble result = 0;
	GET_DOUBLESIZE(v2);
	GET_DOUBLESIZE(v1);
	result = v1 - ( v1 / v2 ) * v2;
	SET_DOUBLESIZE(result);
}

void inst_ineg( type_frame* frame )
{
	*(jint*)(frame->tos) = 0 - *(jint*)(frame->tos);
}

void inst_lneg( type_frame* frame )
{
	jlong val;
	GET_DOUBLESIZE(val);
	val = -val;
	SET_DOUBLESIZE(val);
}

void inst_fneg( type_frame* frame )
{
	exit(0);
	*(jfloat*)(frame->tos) = 0.0f - *(jfloat*)(frame->tos);
}

void inst_dneg( type_frame* frame )
{
	exit(0);
	jdouble val;
	GET_DOUBLESIZE(val);
	val = -val;
	SET_DOUBLESIZE(val);
}

void inst_ishl( type_frame* frame )
{
	// shift range is limited to 31(0x1F)
	jint tmp = pop(jint) & 0x0000001F;
	jint val = pop(jint);
	val <<= tmp;
	push(val);
}

void inst_lshl( type_frame* frame )
{
	// shift range is limited to 63(0x3F)
	jint tmp = pop(jint) & 0x0000003F;
	jlong val;
	GET_DOUBLESIZE(val);
	val <<= tmp;
	SET_DOUBLESIZE(val);
}

// arithmethic shift right
void inst_ishr( type_frame* frame )
{
	jint tmp = pop(jint) & 0x0000001F;
	jint val = pop(jint);
	val >>= tmp;
	push(val);
}

void inst_lshr( type_frame* frame )
{
	jint tmp = pop(jint) & 0x0000003F;
	jlong val;
	GET_DOUBLESIZE(val);
	val >>= tmp;
	SET_DOUBLESIZE(val);
}

void inst_iushr( type_frame* frame )
{
	jint tmp = pop(jint) & 0x0000001F;
	*(u4*)(frame->tos) >>= tmp;
}

void inst_lushr( type_frame* frame )
{
	jint tmp = pop(jint) & 0x0000003F;
	u8 val;
	GET_DOUBLESIZE(val);
	val >>= tmp;
	SET_DOUBLESIZE(val);
}

void inst_iand( type_frame* frame )
{
	*(u4*)(frame->tos-1) &= *(u4*)(frame->tos);
	(frame->tos)--;
}

void inst_land( type_frame* frame )
{
	*(u4*)(frame->tos-3) &= *(u4*)(frame->tos-1);
	*(u4*)(frame->tos-2) &= *(u4*)(frame->tos);
	(frame->tos)-=2;
}

void inst_ior( type_frame* frame )
{
	*(u4*)(frame->tos-1) |= *(u4*)(frame->tos);
	(frame->tos)--;
}

void inst_lor( type_frame* frame )
{
	*(u4*)(frame->tos-3) |= *(u4*)(frame->tos-1);
	*(u4*)(frame->tos-2) |= *(u4*)(frame->tos);
	(frame->tos)-=2;
}

void inst_ixor( type_frame* frame )
{
	*(u4*)(frame->tos-1) ^= *(u4*)(frame->tos);
	(frame->tos)--;
}

void inst_lxor( type_frame* frame )
{
	*(u4*)(frame->tos-3) ^= *(u4*)(frame->tos-1);
	*(u4*)(frame->tos-2) ^= *(u4*)(frame->tos);
	(frame->tos)-=2;
}

void inst_iinc( type_frame* frame )
{
	u1 index = frame->pc[1];
	signed char value = frame->pc[2];

	frame->local[index] = (jint)frame->local[index] + value;
}

// conversions

void inst_i2l( type_frame* frame )
{
	jlong l = POP(jint);
	SET_DOUBLESIZE(l);
}

void inst_i2f( type_frame* frame )
{
	jfloat f = POP(jint);
	PUSH(f,jfloat);
}

void inst_i2d( type_frame* frame )
{
	exit(0);
	jdouble d = POP(jint);
	SET_DOUBLESIZE(d);
}

void inst_l2i( type_frame* frame )
{
	jlong l;
	jint i;
	GET_DOUBLESIZE(l);
	i = (signed int)l;
	PUSH(i,jint);
}

void inst_l2f( type_frame* frame )
{
	exit(0);
	jlong l;
	jfloat f;
	GET_DOUBLESIZE( l );
	f = (jfloat)l;
	push( f );
}

void inst_l2d( type_frame* frame )
{
	exit(0);
	jlong l;
	jdouble d;
	GET_DOUBLESIZE( l );
	d = (jlong)l;
	SET_DOUBLESIZE( d );
}

void inst_f2i( type_frame* frame )
{
	jfloat i = POP(jfloat);
	PUSH( i, jint );
}

void inst_f2l( type_frame* frame )
{
	exit(0);
	jfloat f = pop(jfloat);
	jlong l = (jlong)f;
	SET_DOUBLESIZE( l );
}

void inst_f2d( type_frame* frame )
{
	exit(0);
	jfloat f = pop(jfloat);
	jdouble d = (jdouble)f;
	SET_DOUBLESIZE( d );
}

void inst_d2i( type_frame* frame )
{
	exit(0);
	jdouble d;
	jint i;
	GET_DOUBLESIZE( d );
	i = (jint)d;
	push( i );
}

void inst_d2l( type_frame* frame )
{
	exit(0);
	jdouble d;
	jlong l;
	GET_DOUBLESIZE( d );
	l = (jlong)d;
	SET_DOUBLESIZE( l );
}

void inst_d2f( type_frame* frame )
{
	exit(0);
	jdouble d;
	jfloat f;
	GET_DOUBLESIZE( d );
	f = (jfloat)d;
	push( f );
}

void inst_i2b( type_frame* frame )
{
	jbyte b = POP(jint) & 0xff;
	PUSH(b,jbyte);
}

void inst_i2c( type_frame* frame )
{
	jchar c = POP(jint) & 0xffff;
	PUSH(c,jchar);
}

void inst_i2s( type_frame* frame )
{
	exit(0);
	jint i = pop(jint);
	jshort s = (jshort)i;
	u4 data = s & 0xffff;
	push( data );
}

// compare

void inst_lcmp( type_frame* frame )
{
	jlong val1;
	jlong val2;

	GET_DOUBLESIZE( val2 );
	GET_DOUBLESIZE( val1 );

	if( val1 == val2 )
	{	push(0);}
	else if( val1 > val2 )
	{	push(1);}
	else
	{	push(-1);}
}

void inst_fcmpl( type_frame* frame )
{
	u4 op2 = pop(u4);
	u4 op1 = pop(u4);

	if( ( ((op2&0x7f800000)==0x7f800000) && (op2&0x007fffff) ) ||
	    ( ((op1&0x7f800000)==0x7f800000) && (op1&0x007fffff) ) )
	{	push(-1);}
	else if( (jfloat)op1 == (jfloat)op2 )
	{	push(0);}
	else if( (jfloat)op1  > (jfloat)op2 )
	{	push(1);}
	else
	{	push(-1);}
}

void inst_fcmpg( type_frame* frame )
{
	u4 op2 = pop(u4);
	u4 op1 = pop(u4);

	if( ( ((op2&0x7f800000)==0x7f800000) && (op2&0x007fffff) ) ||
	    ( ((op1&0x7f800000)==0x7f800000) && (op1&0x007fffff) ) )
	{	push(1);}
	else if( (jfloat)op1 == (jfloat)op2 )
	{	push(0);}
	else if( (jfloat)op1  > (jfloat)op2 )
	{	push(1);}
	else
	{	push(-1);}
}

void inst_dcmpl( type_frame* frame )
{
	u8 op1;
	u8 op2;

	GET_DOUBLESIZE( op2 );
	GET_DOUBLESIZE( op1 );
	
	if( ( ((op2&0x7ff0000000000000)==0x7ff0000000000000) && (op2&0x000fffffffffffff) ) ||
	    ( ((op1&0x7ff0000000000000)==0x7ff0000000000000) && (op1&0x000fffffffffffff) ) )
	{	push(-1);}
	else if( (jdouble)op1 == (jdouble)op2 )
	{	push(0);}
	else if( (jdouble)op1  > (jdouble)op2 )
	{	push(1);}
	else
	{	push(-1);}
}

void inst_dcmpg( type_frame* frame )
{
	u8 op1;
	u8 op2;

	GET_DOUBLESIZE( op2 );
	GET_DOUBLESIZE( op1 );
	
	if( ( ((op2&0x7ff0000000000000)==0x7ff0000000000000) && (op2&0x000fffffffffffff) ) ||
	    ( ((op1&0x7ff0000000000000)==0x7ff0000000000000) && (op1&0x000fffffffffffff) ) )
	{	push(1);}	
	else if( (jdouble)op1 == (jdouble)op2 )
	{	push(0);}
	else if( (jdouble)op1  > (jdouble)op2 )
	{	push(1);}
	else
	{	push(-1);}
}

// BRANCH ------------------------------------------------------------------------

void inst_ifeq( type_frame* frame )
{
	u1* buf = frame->pc;
	short dest = (buf[1] << 8) | (buf[2]);
	jint exp = pop(jint);
	if( exp == 0 )
		frame->pc += dest - 3 ;
}

void inst_ifne( type_frame* frame )
{
	u1* buf = frame->pc;
	short dest = (buf[1] << 8) | (buf[2]);
	jint exp = pop(jint);
	if( exp != 0 )
		frame->pc += dest - 3 ;
}

void inst_iflt( type_frame* frame )
{
	u1* buf = frame->pc;
	short dest = (buf[1] << 8) | (buf[2]);
	jint exp = pop(jint);
	if( exp < 0 )
		frame->pc += dest - 3 ;
}

void inst_ifge( type_frame* frame )
{
	u1* buf = frame->pc;
	short dest = (buf[1] << 8) | (buf[2]);
	jint exp = pop(jint);
	if( exp >= 0 )
		frame->pc += dest - 3 ;
}

void inst_ifgt( type_frame* frame )
{
	u1* buf = frame->pc;
	short dest = (buf[1] << 8) | (buf[2]);
	jint exp = pop(jint);
	if( exp > 0 )
		frame->pc += dest - 3 ;
}

void inst_ifle( type_frame* frame )
{
	u1* buf = frame->pc;
	short dest = (buf[1] << 8) | (buf[2]);
	jint exp = pop(jint);
	if( exp <= 0 )
		frame->pc += dest - 3 ;
}

/*
 * COMPARATION JUMP --------------------------------------------------------------
 */

void inst_icmpeq( type_frame* frame )
{
	u1* buf = frame->pc;
	short dest = (buf[1] << 8) | (buf[2]);
	jint val2 = pop(jint);
	jint val1 = pop(jint);
	if( val1 == val2 )
		frame->pc += dest - 3;
}

void inst_icmpne( type_frame* frame )
{
	u1* buf = frame->pc;
	short dest = (buf[1] << 8) | (buf[2]);
	jint val2 = pop(jint);
	jint val1 = pop(jint);
	if( val1 != val2 )
		frame->pc += dest - 3;
}

void inst_icmplt( type_frame* frame )
{
	u1* buf = frame->pc;
	short dest = (buf[1] << 8) | (buf[2]);
	jint val2 = pop(jint);
	jint val1 = pop(jint);
	if( val1 < val2 )
		frame->pc += dest - 3;
}

void inst_icmpge( type_frame* frame )
{
	u1* buf = frame->pc;
	short dest = (buf[1] << 8) | (buf[2]);
	jint val2 = pop(jint);
	jint val1 = pop(jint);
	if( val1 >= val2 )
		frame->pc += dest - 3;
}

void inst_icmpgt( type_frame* frame )
{
	u1* buf = frame->pc;
	short dest = (buf[1] << 8) | (buf[2]);
	jint val2 = pop(jint);
	jint val1 = pop(jint);
	if( val1 > val2 )
		frame->pc += dest - 3;
}

void inst_icmple( type_frame* frame )
{
	u1* buf = frame->pc;
	short dest = (buf[1] << 8) | (buf[2]);
	jint val2 = pop(jint);
	jint val1 = pop(jint);
	if( val1 <= val2 )
		frame->pc += dest - 3;
}

void inst_acmpeq( type_frame* frame )
{
	u1* buf = frame->pc;
	short dest = (buf[1] << 8) | (buf[2]);
	u4 val2 = pop(jint);
	u4 val1 = pop(jint);
	if( val1 == val2 )
		frame->pc += dest - 3;
}

void inst_acmpne( type_frame* frame )
{
	u1* buf = frame->pc;
	short dest = (buf[1] << 8) | (buf[2]);
	u4 val2 = pop(jint);
	u4 val1 = pop(jint);
	if( val1 != val2 )
		frame->pc += dest - 3;
}

void inst_goto( type_frame* frame )
{
	u1* buf = frame->pc;
	short dest = (buf[1] << 8) | (buf[2]);
	frame->pc += dest - 3;
}

/*
 * subroutine
 * 1. push(add)
 * 2. jump
 * 3. sub pop(add) -> store(local)
 * 4. ...
 * 5. ret load(local)
 */

void inst_jsr( type_frame* frame )
{
	u1* buf = frame->pc;
	short dest = (buf[1] << 8) | (buf[2]);
	push( frame->pc );
	frame->pc += dest - 3;
}

void inst_ret( type_frame* frame )
{
	u1* buf = frame->pc;
	u4 add = frame->local[buf[1]];
	frame->pc = add + 1;
}

void inst_tableswitch( type_frame* frame )
{
	u1* buffer = frame->pc;
	int def, low, high, index;
	int skip = (int)((int)buffer%4);


	buffer = buffer + 4 - (((int)(frame->pc - frame->base))%4);
	def  = ( buffer[0]<<24 | buffer[1]<<16 | buffer[ 2]<<8 | buffer[ 3] );
	low  = ( buffer[4]<<24 | buffer[5]<<16 | buffer[ 6]<<8 | buffer[ 7] );
	high = ( buffer[8]<<24 | buffer[9]<<16 | buffer[10]<<8 | buffer[11] );
	index = POP(u4);

	printf("frame %x %x %x %x \n", def, low, high, index );
		
	if( index < low || index > high )
		frame->pc += def - 1;
	else
	{
		buffer = buffer + (index-low)*4 + 12;
		frame->pc += ( buffer[0]<<24 | buffer[1]<<16 | buffer[2]<<8 | buffer[3] ) - 1;
	}
}

void inst_lookupswitch( type_frame* frame )
{
	exit(0);
/*
	runnable* execute_data = gTT()->frame;
	int *tabpc = (int*)((int)(execute_data->pc + 1 + 3) & ~0x3);
	int32 deflt  = c_ntohl(tabpc[0]);
	int32 npairs = c_ntohl(tabpc[1]);
	int key    = pop();
        int i;

        for(i = 2 ; (i < npairs*2+2) && ( key != c_ntohl(tabpc[i]) ) ; i += 2)
	if(i == npairs*2+2)
        	execute_data->pc += deflt;
        else
        	execute_data->pc += c_ntohl(tabpc[i+1]);

	exit(0);
*/
}

// return

void inst_ireturn( type_frame* frame )
{
	u4 temp = pop(u4);
	frame = frame->prv;
	push(temp);
}

void inst_lreturn( type_frame* frame )
{
	jlong ret = 0;
	GET_DOUBLESIZE(ret);
	frame = frame->prv;
	SET_DOUBLESIZE(ret);
}
/*
void inst_freturn()
{
	u4 temp = 0;
	runnable* cur = gTT()->frame;
	temp = pop();
	gTT()->frame = cur->prv;
	push((u4)temp);
	gTT()->frame = cur;
}

void inst_dreturn()
{
	jdouble ret = 0;
	runnable *cur = gTT()->frame;
	GET_DOUBLESIZE(ret);
	gTT()->frame = cur->prv;
	SET_DOUBLESIZE(ret);
	gTT()->frame = cur;
}

void inst_areturn()
{
	u4 temp = 0;
	runnable *cur = gTT()->frame;
	temp = pop();
	gTT()->frame = cur->prv;
	push((u4)temp);
	gTT()->frame = cur;
}
*/

void inst_return( type_frame* frame )
{
}

void inst_getstatic( type_frame* frame )
{
	type_class*	cls;
	type_constant*	constant_pool;
	type_field*	variable;
	u1*		buffer;
	u2		index;


	constant_pool = frame->pool;
	buffer = frame->pc;
	index = (buffer[1]<<8) | buffer[2];

	variable = (constant_pool->data)[index];
	cls = variable->cls;
	// 3rd ACTIVE USE
	if( cls->state != CLASSSTATE_COMPLETED )
		initClass( cls, 0 ); 

	if( (constant_pool->tag)[index]	== CONSTANT_DOUBLE ||
		(constant_pool->tag)[index] == CONSTANT_LONG )
	{
		push( variable->position );
		push( variable->size );
	}
	else
	{
		push( variable->size );
	}
}

void inst_putstatic( type_frame* frame )
{
	type_class*	cls;
	type_constant*	constant_pool;
	type_field*	variable;
	u1*		buffer;
	u2		index;


	constant_pool = frame->pool;
	buffer = frame->pc;
	index = (buffer[1]<<8) | buffer[2];

	variable = (constant_pool->data)[index];
	cls = variable->cls;
	// 3rd ACTIVE USE
	if( cls->state != CLASSSTATE_COMPLETED )
		initClass( cls, 0 ); 

	if( (constant_pool->tag)[index]	== CONSTANT_DOUBLE ||
		(constant_pool->tag)[index] == CONSTANT_LONG )
	{
		variable->size = pop(u4);
		variable->position = pop(u4);
	}
	else
	{
		variable->size = pop(u4);
	}
}

void inst_getfield( type_frame* frame )
{
	u1* buffer;
	u4* ptr4;
	u2 index;
	u4 value;
	u8 dvalue;
	type_field* field;
	type_constant* pool;
	type_object* object;
	u1* data;


	buffer = frame->pc;
	pool = frame->pool;
	index = (buffer[1]<<8) | buffer[2];

	field = (pool->data)[index];

	if( field->size == 4 )
	{
		object = pop(u4);
		if( object == 0 )
		{
			exit(0);
		}
		
		/* debug */
		if( object->ref == 0 )
		{
			printf("reference null\n");
			exit(0);
		}
		
		memcpy(&value, (u1*)object->ref+(int)field->position, 4);
		push( value );
	}
	else
	{
		object = pop(u4);
		memcpy(&dvalue, (u1*)object->ref+(int)field->position, 8);
		SET_DOUBLESIZE( dvalue );
	}
}

void inst_putfield( type_frame* frame )
{
	u1* buffer;
	u4* ptr4;
	u2 index;
	u4 value;
	u8 dvalue;
	type_field* field;
	type_constant* pool;
	type_object* object;
	u1* data;


	buffer = frame->pc;
	pool = frame->pool;
	index = (buffer[1]<<8) | buffer[2];

	field = (pool->data)[index];

	if( field->size == 4 )
	{
		value = pop(u4);
		object = pop(u4);
		memcpy( (u1*)object->ref+(int)field->position, &value, 4);
	}
	else
	{
		GET_DOUBLESIZE( dvalue );
		object = pop(u4);
		memcpy( (u1*)object->ref+(int)field->position, &dvalue, 8);
	}
}

void inst_invokevirtual( type_frame* frame )
{
	u1* buffer;
	u2 index;
	type_method_table* mtable;
	type_constant* pool;


	buffer = frame->pc;
	pool = frame->pool;

	index = (buffer[1]<<8) | buffer[2];
	mtable = (pool->data)[index];

	mtable = findInheritedMethod( mtable, frame );
	invokeMethod( mtable, frame );
}

void inst_invokespecial( type_frame* frame )
{
	u1* buffer;
	u2 index;
	type_method_table* mtable;
	type_constant* pool;


	buffer = frame->pc;
	pool = frame->pool;

	index = (buffer[1]<<8) | buffer[2];
	mtable = (pool->data)[index];

	invokeMethod( mtable, frame );
}

void inst_invokestatic( type_frame* frame )
{
	u1* buffer;
	u2 index;
	type_method_table* mtable;
	type_constant* pool;


	buffer = frame->pc;
	pool = frame->pool;
	
	index = (buffer[1]<<8) | buffer[2];
	mtable = (pool->data)[index];

	invokeMethod( mtable, frame );
}

void inst_invokeinterface( type_frame* frame )
{
	u1* buffer;
	u2 index;
	type_method_table* mtable;
	type_constant* pool;


	buffer = frame->pc;
	pool = frame->pool;

	index = (buffer[1]<<8) | buffer[2];
	mtable = (pool->data)[index];

	mtable = findInheritedMethod( mtable, frame );
	invokeMethod( mtable, frame );
}

void inst_new( type_frame* frame )
{
	u1* buffer;
	u2 index;
	type_constant* pool;
	type_object* object;


	buffer = frame->pc;
	pool = frame->pool;
	index = (buffer[1]<<8) | buffer[2];
	object = newObject( (pool->data)[index] );
	PUSH( object, u4 );
}

void inst_newarray( type_frame* frame )
{
	u1* buffer;
	u1 type;
	type_array* array;


	buffer = frame->pc;
	type = buffer[1];
	array = newArray( (u4)type, POP(jint) );
	PUSH( array, u4 );
}

void inst_anewarray( type_frame* frame )
{
	u1* buffer;
	u2 index;
	type_constant* pool;
	type_class* class;
	type_array* array;


	buffer = frame->pc;
	pool = frame->pool;
	index = (buffer[1]<<8) | buffer[2];

	class = (pool->data)[index];

	array = newObjectArray( class, pop(jint) );

	push( array );
}

void inst_arraylength( type_frame* frame )
{
	type_array* array;
	unsigned int length;


	array = pop(u4);
	length = array->length;
	push(length);
}

// Thorow execption or error

void inst_athrow( type_frame* frame )
{
	type_object* object = POP(u4); 
	frame->exception = object;
	frame->tos = frame->stack;
	*(frame->tos) = object;
}

void inst_checkcast( type_frame* frame )
{
}

void inst_instanceof( type_frame* frame )
{
	u1* buffer;
	u2 index;
	type_class* class;
	type_object* object;
	type_constant* pool;


	buffer = frame->pc;
	pool = frame->pool;
	index = (buffer[1]<<8) | buffer[2];
	class = (pool->data)[index];
	object = POP(u4);

	if( object != 0 && instanceOf( class, object->cls ) )
	{
		PUSH(1,u4);
	}
	else
	{
		PUSH(0,u4);
	}
}

void inst_monitorenter( type_frame* frame )
{
	POP(u4);
	// If the objectref word is null,
	// the virtual machine throws NullPointerException

/*
	Hjava_lang_Object* objref;
	objref = (Hjava_lang_Object*)pop();

	lock(objref);
	
//	printf("monitor enter\n");
*/
}

void inst_monitorexit( type_frame* frame )
{
	POP(u4);
	// If the objectref word is null,
	// thr virtual machine throws NullPointerException

/*
	Hjava_lang_Object* objref;
	objref = (Hjava_lang_Object*)pop();

	unlock(objref);
//	printf("monitor exit\n");
*/
}

void inst_wide( type_frame* frame )
{
	printf("wide instruction\n");
	exit(0);
}

void inst_multianewarray( type_frame* frame )
{
	printf("multi array instruction\n");
	exit(0);
}

void inst_ifnull( type_frame* frame )
{
	u1* buf = frame->pc;
	if( pop(u4) == 0 )
		frame->pc += (short)( buf[1] << 8 | buf[2] ) - 3 ;
}

void inst_ifnonnull( type_frame* frame )
{
	u1* buf = frame->pc;
	if( pop(u4) != 0 )
		frame->pc += (short)( buf[1] << 8 | buf[2] ) - 3 ;
}

void inst_goto_w( type_frame* frame )
{
	u1* buf = frame->pc;
	u4 dest = ((buf[1]<<24) | (buf[2]<<16) | (buf[3]<<8) | (buf[4]));
//	frame->pc = execute_data->base + dest;

	exit(0);
}

void inst_jsr_w( type_frame* frame )
{
	exit(0);
}

void inst_breakpoint( type_frame* frame )
{
	exit(0);
	// reserved.
}

// quick instructions below.

void inst_ldc_quick()
{
	exit(0);
}

void inst_ldc_w_quick()
{
	exit(0);
}

void inst_ldc2_w_quick()
{
	exit(0);
}

void inst_getfield_quick()
{
	exit(0);
}

void inst_putfield_quick()
{
	exit(0);
}

void inst_getfield2_quick()
{
	exit(0);
}

void inst_putfield2_quick()
{
	exit(0);
}

void inst_getstatic_quick()
{
	exit(0);
}

void inst_putstatic_quick()
{
	exit(0);
}

void inst_getstatic2_quick()
{
	exit(0);
}

void inst_putstatic2_quick()
{
	exit(0);
}

void inst_invokevirtual_quick()
{
	exit(0);
}

void inst_invokenonvirtual_quick()
{
	exit(0);
}

void inst_invokesuper_quick()
{
	exit(0);
}

void inst_invokestatic_quick()
{
	exit(0);
}

void inst_invokeinterface_quick()
{
	exit(0);
}

void inst_invokevirtualobject_quick()
{
	exit(0);
}

void inst_new_quick()
{
	exit(0);
}

void inst_anewarray_quick()
{
	exit(0);
}

void inst_multianewarray_quick()
{
	exit(0);
}

void inst_checkcast_quick()
{
	exit(0);
}

void inst_instanceof_quick()
{
	exit(0);
}

void inst_invokevirtual_quick_w()
{
	exit(0);
}

void inst_getfield_quick_w()
{
	exit(0);
}

void inst_putfield_quick_w( type_frame* frame )
{
	exit(0);
}

#endif
