
typedef void (*inst_ptr)(type_frame*);


const inst_ptr inst_map[256] = {
	inst_nop,
	inst_aconst_null,
	inst_iconst_m1,
	inst_iconst_0,
	inst_iconst_1,
	inst_iconst_2,
	inst_iconst_3,
	inst_iconst_4,
	inst_iconst_5,
	inst_lconst_0,
	inst_lconst_1,
	inst_fconst_0,
	inst_fconst_1,
	inst_fconst_2,
	inst_dconst_0,
	inst_dconst_1,
	inst_bipush,
	inst_sipush,
	inst_ldc,
	inst_ldc_w,
	inst_ldc2_w,
	inst_iload,
	inst_lload,
	inst_iload,	//	inst_fload,
	inst_lload,	//	inst_dload,
	inst_iload,	//	inst_aload,
	inst_iload_0,
	inst_iload_1,
	inst_iload_2,
	inst_iload_3,
	inst_lload_0,
	inst_lload_1,
	inst_lload_2,
	inst_lload_3,
	inst_iload_0,	//	inst_fload_0,
	inst_iload_1,	//	inst_fload_1,
	inst_iload_2,	//	inst_fload_2,
	inst_iload_3,	//	inst_fload_3,
	inst_lload_0,	//	inst_dload_0,
	inst_lload_1,	//	inst_dload_1,
	inst_lload_2,	//	inst_dload_2,
	inst_lload_3,	//	inst_dload_3,
	inst_iload_0,	//	inst_aload_0,
	inst_iload_1,	//	inst_aload_1,
	inst_iload_2,	//	inst_aload_2,
	inst_iload_3,	//	inst_aload_3,
	inst_iaload,
	inst_laload,
	inst_faload,
	inst_daload,
	inst_aaload,
	inst_baload,
	inst_caload,
	inst_saload,
	inst_istore,
	inst_lstore,
	inst_istore,	//	inst_fstore,
	inst_lstore,	//	inst_dstore,
	inst_istore,	//	inst_astore,
	inst_istore_0,
	inst_istore_1,
	inst_istore_2,
	inst_istore_3,
	inst_lstore_0,
	inst_lstore_1,
	inst_lstore_2,
	inst_lstore_3,
	inst_istore_0,	//	inst_fstore_0,
	inst_istore_1,	//	inst_fstore_1,
	inst_istore_2,	//	inst_fstore_2,
	inst_istore_3,	//	inst_fstore_3,
	inst_lstore_0,	//	inst_dstore_0,
	inst_lstore_1,	//	inst_dstore_1,
	inst_lstore_2,	//	inst_dstore_2,
	inst_lstore_3,	//	inst_dstore_3,
	inst_istore_0,	//	inst_astore_0,
	inst_istore_1,	//	inst_astore_1,
	inst_istore_2,	//	inst_astore_2,
	inst_istore_3,	//	inst_astore_3,
	inst_iastore,
	inst_lastore,
	inst_fastore,
	inst_dastore,
	inst_aastore,
	inst_bastore,
	inst_castore,
	inst_sastore,
	inst_pop,
	inst_pop2,
	inst_dup,
	inst_dup_x1,
	inst_dup_x2,
	inst_dup2,
	inst_dup2_x1,
	inst_dup2_x2,
	inst_swap,
	inst_iadd,
	inst_ladd,
	inst_fadd,
	inst_dadd,
	inst_isub,
	inst_lsub,
	inst_fsub,
	inst_dsub,
	inst_imul,
	inst_lmul,
	inst_fmul,
	inst_dmul,
	inst_idiv,
	inst_ldiv,
	inst_fdiv,
	inst_ddiv,
	inst_irem,
	inst_lrem,
	inst_frem,
	inst_drem,
	inst_ineg,
	inst_lneg,
	inst_fneg,
	inst_dneg,
	inst_ishl,
	inst_lshl,
	inst_ishr,
	inst_lshr,
	inst_iushr,
	inst_lushr,
	inst_iand,
	inst_land,
	inst_ior,
	inst_lor,
	inst_ixor,
	inst_lxor,
	inst_iinc,
	inst_i2l,
	inst_i2f,
	inst_i2d,
	inst_l2i,
	inst_l2f,
	inst_l2d,
	inst_f2i,
	inst_f2l,
	inst_f2d,
	inst_d2i,
	inst_d2l,
	inst_d2f,
	inst_i2b,
	inst_i2c,
	inst_i2s,
	inst_lcmp,
	inst_fcmpl,
	inst_fcmpg,
	inst_dcmpl,
	inst_dcmpg,
	inst_ifeq,
	inst_ifne,
	inst_iflt,
	inst_ifge,
	inst_ifgt,
	inst_ifle,
	inst_icmpeq,
	inst_icmpne,
	inst_icmplt,
	inst_icmpge,
	inst_icmpgt,
	inst_icmple,
	inst_acmpeq,
	inst_acmpne,
	inst_goto,
	inst_jsr,
	inst_ret,
	inst_tableswitch,
	inst_lookupswitch,
	inst_ireturn,
	inst_lreturn,
	inst_ireturn,	//	inst_freturn,
	inst_lreturn,	//	inst_dreturn,
	inst_ireturn,	//	inst_areturn,
	inst_return,
	inst_getstatic,
	inst_putstatic,
	inst_getfield,
	inst_putfield,
	inst_invokevirtual,
	inst_invokespecial,
	inst_invokestatic,
	inst_invokeinterface,
	0,
	inst_new,
	inst_newarray,
	inst_anewarray,
	inst_arraylength,
	inst_athrow,
	inst_checkcast,
	inst_instanceof,
	inst_monitorenter,
	inst_monitorexit,
	inst_wide,
	inst_multianewarray,
	inst_ifnull,
	inst_ifnonnull,
	inst_goto_w,
	inst_jsr_w,

	inst_breakpoint,	// reserved.

// quick instructions below.
	inst_ldc_quick,
	inst_ldc_w_quick,
	inst_ldc2_w_quick,
	inst_getfield_quick,
	inst_putfield_quick,
	inst_getfield2_quick,
	inst_putfield2_quick,
	inst_getstatic_quick,
	inst_putstatic_quick,
	inst_getstatic2_quick,
	inst_putstatic2_quick,
	inst_invokevirtual_quick,
	inst_invokenonvirtual_quick,
	inst_invokesuper_quick,
	inst_invokestatic_quick,
	inst_invokeinterface_quick,
	inst_invokevirtualobject_quick,
	inst_new_quick,
	inst_anewarray_quick,
	inst_multianewarray_quick,
	inst_checkcast_quick,
	inst_instanceof_quick,
	inst_invokevirtual_quick_w,
	inst_getfield_quick_w,
	inst_putfield_quick_w,

	0,0,		// 230
	0,0,0,0,0,
	0,0,0,0,0,
	0,0,0,0,0,
	0,0,0,0,0,	// 250
	0,0,0,		// 253

	0,			//inst_impdep1,
	0,			//inst_impdep2,
};
