/*
 * jni.c
 * Java Native Interface.
 */

#include <stdlib.h>
#include "type.h"
#include "jtypes.h"
#include "jni.h"
//#include "./jni.h"
//#include "../typendata/data_structure.h"
//#include "../typendata/arrays.h"
//#include "../gc/gc.h"
//#include "../loader/loader.h"
//#include "../loader/field.h"
//#include "../loader/utf8.h"
//#include "../execution/execute.h"
//#include "../execution/call.h"		// gT()-> 
//#include "../execution/string.h"	// is it use? 
//#include "read.h"
//#include "string.h"
//#include "native.h"
//#include "exception.h"
//

#include "memory.h"

static int Kaffe_NumVM = 0;

//uintp Kaffe_JNI_estart;
//uintp Kaffe_JNI_eend;

extern struct JNINativeInterface	jni_NativeInterface;
extern struct JNIEnv_			jni_Env;
extern struct JNIInvokeInterface	jni_InvokeInterface;

extern JavaVMInitArgs jni_JavaVMInitArgs;
extern JavaVM jni_JavaVM;



/* -----------------------------------------------------------------------------
 * Invocation API Functions
 * ---------------------------------------------------------------------------*/


jint JNI_GetDefaultJavaVMInitArgs(JavaVMInitArgs* vm_args)
//jint JNI_GetDefaultJavaVMInitArgs(void* vm_args)
{
	if( vm_args->version != 0x00010001 )
	{
		return (-1);
	}
	memcpy(vm_args, &jni_JavaVMInitArgs, sizeof(JavaVMInitArgs));
	vm_args->version = 0x00010001;
	return (0);
}

jint JNI_CreateJavaVM(JavaVM** p_vm, JNIEnv** p_env, JavaVMInitArgs* vm_args)
{
	if( vm_args->version != 0x00010001 )
		return (-1);

//	initJVM(&jni_Env);

	*p_vm = &jni_JavaVM;
	*p_env = &jni_Env;
		
	return (0);
}

// JDK 1.1.2 does not support creating more than one VM in a single process
jint JNI_GetCreatedJavaVMs(JavaVM** vmBuf, jsize bufLen, jsize* nVMs)
{
	vmBuf[0] = &jni_JavaVM;
	*nVMs = Kaffe_NumVM;

	return (0);
}

/*-----------------------------------------------------------------------------
 * JNI support functions
 *---------------------------------------------------------------------------*/
/*
static void
postError(JNIEnv* env, errorInfo* info)
{
//	Kaffe_Throw(env, error2Throwable(info));
}
*/
/*-----------------------------------------------------------------------------
 * JNI implemented functions
 *---------------------------------------------------------------------------*/

/* ----------------------------------------------------------------------------
 * Version Information
 * --------------------------------------------------------------------------*/

static jint
JNI_GetVersion(JNIEnv* env)
{
	return (0x00010001);
}

/* ----------------------------------------------------------------------------
 * Class Operation
 * --------------------------------------------------------------------------*/

/*
static jclass
JNI_DefineClass(JNIEnv* env, jobject loader, const jbyte* buf, jsize len)
{
	type_class* cls;
	class_file hand;

	BEGIN_EXCEPTION_HANDLING(0);
	hand.buf = (void*)buf;
	hand.size = len;

	hand.type = 1;

//	cls = new_class();
//	if (cls == 0) {
//		postOutOfMemory(&info);
//	} else {
//		cls->loader = loader;
//		read_class_data(cls, &hand);
//		link_class_list(cls, loader);
//	}
	if (cls == 0) {
//		postError(env, &info);
	}

	END_EXCEPTION_HANDLING();
	return (cls);
}
*/

static jclass JNI_FindClass(JNIEnv* env, const char* name)
{
	type_class* class;
	class = cload( loadUtf8(name), 0 );
	return class;
}

/*
static jclass
JNI_GetSuperClass(JNIEnv* env, jclass cls)
{
	jclass ret;

	BEGIN_EXCEPTION_HANDLING(0);

	ret = ((Hjava_lang_Class*)cls)->super;

	END_EXCEPTION_HANDLING();
	return (ret);
}

//bool instanceof(Hjava_lang_Class*,Hjava_lang_Class*);

static jbool
JNI_IsAssignableFrom(JNIEnv* env, jclass cls1, jclass cls2)
{
	jbool ret;

	BEGIN_EXCEPTION_HANDLING(0);

	if ( instanceof(cls2, cls1) )
       	{
		ret = JNI_TRUE;
	}
	else
       	{
		ret = JNI_FALSE;
	}
	END_EXCEPTION_HANDLING();
	return (ret);
}

*/

/* ----------------------------------------------------------------------------
 * Exceptions
 * --------------------------------------------------------------------------*/

/*
static jint
JNI_Throw(JNIEnv* env, jobject obj)
{
	BEGIN_EXCEPTION_HANDLING(0);

//	(getCurrentThread())->exceptObj = (struct Hjava_lang_Throwable*)obj;

	END_EXCEPTION_HANDLING();
	return (0);
}

static jint
JNI_ThrowNew(JNIEnv* env, jclass cls, const char* mess)
{
	Hjava_lang_Object* eobj;

	BEGIN_EXCEPTION_HANDLING(0);

	eobj = execute_java_constructor(NULL, NULL, cls,
					"(Ljava/lang/String;)V",
//					checkPtr(cstring_to_java((char*)mess)));
					cstring_to_java(mess));
			
//	(getCurrentThread())->exceptObj = (struct Hjava_lang_Throwable*)eobj;

	END_EXCEPTION_HANDLING();
	return (0);
}
*/

static jobject
JNI_ExceptionOccurred(JNIEnv* env)
{
//	jobject obj = 0;

//	BEGIN_EXCEPTION_HANDLING(0);

//	obj = unhand(getCurrentThread())->exceptObj;
//	obj = (getCurrentThread())->exceptObj;

//	ADD_REF(obj);
//	END_EXCEPTION_HANDLING();
	return (0);
}

/*
static void
JNI_ExceptionDescribe(JNIEnv* env)
{
	BEGIN_EXCEPTION_HANDLING_VOID();

//	if (unhand(getCurrentThread())->exceptObj != 0) {
//	if( (getCurrentThread())->exceptObj != 0 ) {
//		do_execute_java_method( (getCurrentThread())->exceptObj, "printStackTrace", "()V", 0, 0,
//			       		(getCurrentThread())->exceptObj); 
//	}

	END_EXCEPTION_HANDLING();
}

static void
JNI_ExceptionClear(JNIEnv* env)
{
	BEGIN_EXCEPTION_HANDLING_VOID();

//	unhand(getCurrentThread())->exceptObj = 0;
//	(getCurrentThread())->exceptObj = 0;

	END_EXCEPTION_HANDLING();
}

static void
JNI_FatalError(JNIEnv* env, const char* mess)
{
//	kprintf(stderr, "FATAL ERROR: %s\n", mess);
	exit(1);
}

*/

/* ----------------------------------------------------------------------------
 * Global and Local Reference
 * --------------------------------------------------------------------------*/

/*
static jref
JNI_NewGlobalRef(JNIEnv* env, jref obj)
{
	BEGIN_EXCEPTION_HANDLING(0);
	
//	if (!gc_add_ref(obj)) {
//		errorInfo info;
//		postOutOfMemory(&info);
//		postError(env, &info);
//	}
	
	END_EXCEPTION_HANDLING();
	
	return obj;
}

static void
JNI_DeleteGlobalRef(JNIEnv* env, jref obj)
{
//	gc_rm_ref(obj);
}

static void
JNI_DeleteLocalRef(JNIEnv* env, jref obj)
{
	REMOVE_REF(obj);
}

static jboolean
JNI_IsSameObject(JNIEnv* env, jobject obj1, jobject obj2)
{
	if (obj1 == obj2) {
		return (JNI_TRUE);
	}
	else {
		return (JNI_FALSE);
	}
}

*/

/* ----------------------------------------------------------------------------
 * Object Operations
 * --------------------------------------------------------------------------*/

/*
inline void
call_special_method_v(methods* meth, Hjava_lang_Class* cls,
		Hjava_lang_Object* obj, va_list args, jvalue* ret);

inline void
call_special_method_a(methods* meth, Hjava_lang_Class* cls,
		Hjava_lang_Object* obj, jvalue* args, jvalue* ret);
*/

/*
static jobject
JNI_AllocObject(JNIEnv* env, jclass cls)
{
	jobject obj;
	Hjava_lang_Class* clazz;

	BEGIN_EXCEPTION_HANDLING(0);

	clazz = (Hjava_lang_Class*)cls;

	if (CLASS_IS_INTERFACE(clazz) || CLASS_IS_ABSTRACT(clazz)) {
//		throwException(InstantiationException(clazz->name->data));
	}
	obj = new_object(clazz);

//	ADD_REF(obj);
	END_EXCEPTION_HANDLING();
	return (obj);
}
*/

static jobject
JNI_NewObjectV(JNIEnv* env, jclass cls, jmethodID meth, va_list args)
{
	type_class* class = cls;
	jobject* object;
	jvalue retval;

	if( class->acc_flag & ( ACC_INTERFACE | ACC_ABSTRACT ) )
	{
		printf("throw exception\n");
		exit(0);
	}

	// creator & constructor
	object = newObject(cls);
	invokeExternalValist( meth, object, args );
	return (object);
}

static jobject
JNI_NewObject(JNIEnv* env, jclass cls, jmethodID meth, ...)
{
	jobject obj;
	va_list args;
	va_start(args, meth);
	obj = JNI_NewObjectV(env, cls, meth, args);
	va_end(args);
	return (obj);
}

/*
static jobject
JNI_NewObjectA(JNIEnv* env, jclass cls, jmethodID meth, jvalue* args)
{
	Hjava_lang_Object* obj;
	Hjava_lang_Class* clazz;
	jvalue retval;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	clazz = (Hjava_lang_Class*)cls;

	if (CLASS_IS_INTERFACE(clazz) || CLASS_IS_ABSTRACT(clazz))
//		|| !METHOD_IS_CONSTRUCTOR(m))
	{
//		throwException(InstantiationException(clazz->name->data));
	}
	obj = new_object(clazz);
	call_special_method_a(m, clazz, obj, args, &retval);

//	ADD_REF(obj);
	END_EXCEPTION_HANDLING();
	return (obj);
}
*/

static jclass
JNI_GetObjectClass(JNIEnv* env, jobject obj)
{
	jclass cls;

	cls = ((type_object*)obj)->cls;

	return (cls);
}

/*
static jbool
JNI_IsInstanceOf(JNIEnv* env, jobject obj, jclass cls)
{
	jbool ret;

	BEGIN_EXCEPTION_HANDLING(0);

//	if (instanceof((Hjava_lang_Class*)cls, ((Hjava_lang_Object*)obj)->cls) != 0) {
//	if( instanceof(((Hjava_lang_Object*)obj)->cls, (Hjava_lang_Class*)cls) )
	if( instanceof((Hjava_lang_Class*)cls, ((Hjava_lang_Object*)obj)->cls) )
	{
		ret = JNI_TRUE;
	}
	else
       	{
		ret = JNI_FALSE;
	}

	END_EXCEPTION_HANDLING();
	return (ret);
}

*/

/* ----------------------------------------------------------------------------
 * Calling Instance Methods
 * modified 2004/2/15 by numenor
 *  
 * --------------------------------------------------------------------------*/

static jmethodID
JNI_GetMethodID(JNIEnv* env, jclass cls, const char* name, const char* sig)
{
	type_method_table* method;
//	BEGIN_EXCEPTION_HANDLING(0);
	method = findMethodName( cls, loadUtf8(name), loadUtf8(sig) );
//	END_EXCEPTION_HANDLING();

	return (method);
}

/*---------------------------------------------------------------------------*/

/* added 2004/2/16 by numenor
 *
 * --------------------------------------------------------------------------*/

/*
static jobject
JNI_CallObjectMethodV(JNIEnv* env, jobject obj, jmethodID meth, va_list args)
{
	jvalue retval;
	Hjava_lang_Object* o = (Hjava_lang_Object*)obj;
	methods* m = (methods*)meth;

//	BEGIN_EXCEPTION_HANDLING(0);

//	if (METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
//	}

	call_virtual_method_v(m, obj, args, &retval);

//	ADD_REF(retval.l);
//	END_EXCEPTION_HANDLING();
	return (retval.l);
}

static jobject
JNI_CallObjectMethod(JNIEnv* env, jobject obj, jmethodID meth, ...)
{
	va_list args;
	jobject ret;

	BEGIN_EXCEPTION_HANDLING(0);

	va_start(args, meth);
	ret = JNI_CallObjectMethodV(env, obj, meth, args);
	va_end(args);

	END_EXCEPTION_HANDLING();
	return (ret);
}

static jobject
JNI_CallObjectMethodA(JNIEnv* env, jobject obj, jmethodID meth, jvalue* args)
{
	jvalue retval;
	Hjava_lang_Object* o = (Hjava_lang_Object*)obj;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_virtual_method_a(m, obj, args, &retval);

	END_EXCEPTION_HANDLING();
	return (retval.l);
}

static jboolean
JNI_CallBooleanMethodV(JNIEnv* env, jobject obj, jmethodID meth, va_list args)
{
	jvalue retval;
	Hjava_lang_Object* o = (Hjava_lang_Object*)obj;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_virtual_method_v(m, obj, args, &retval);

	END_EXCEPTION_HANDLING();
	return ((jboolean) retval.i);
}

static jboolean
JNI_CallBooleanMethod(JNIEnv* env, jobject obj, jmethodID meth, ...)
{
	va_list args;
	jboolean ret;

	BEGIN_EXCEPTION_HANDLING(0);

	va_start(args, meth);
	ret = JNI_CallBooleanMethodV(env, obj, meth, args);
	va_end(args);

	END_EXCEPTION_HANDLING();
	return (ret);
}

static jboolean
JNI_CallBooleanMethodA(JNIEnv* env, jobject obj, jmethodID meth, jvalue* args)
{
	jvalue retval;
	Hjava_lang_Object* o = (Hjava_lang_Object*)obj;
//	Method* m = (Method*)meth;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_virtual_method_a(m, obj, args, &retval);

	END_EXCEPTION_HANDLING();
	return ((jboolean) retval.i);
}

static jbyte
JNI_CallByteMethodV(JNIEnv* env, jobject obj, jmethodID meth, va_list args)
{
	jvalue retval;
	Hjava_lang_Object* o = (Hjava_lang_Object*)obj;
//	Method* m = (Method*)meth;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_virtual_method_v(m, obj, args, &retval);

	END_EXCEPTION_HANDLING();
	return ((jbyte) retval.i);
}

static jbyte
JNI_CallByteMethod(JNIEnv* env, jobject obj, jmethodID meth, ...)
{
	va_list args;
	jbyte ret;

	BEGIN_EXCEPTION_HANDLING(0);

	va_start(args, meth);
	ret = JNI_CallByteMethodV(env, obj, meth, args);
	va_end(args);

	END_EXCEPTION_HANDLING();
	return (ret);
}

static jbyte
JNI_CallByteMethodA(JNIEnv* env, jobject obj, jmethodID meth, jvalue* args)
{
	jvalue retval;
	Hjava_lang_Object* o = (Hjava_lang_Object*)obj;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_virtual_method_a(m, obj, args, &retval);

	END_EXCEPTION_HANDLING();
	return ((jbyte) retval.i);
}

static jchar
JNI_CallCharMethodV(JNIEnv* env, jobject obj, jmethodID meth, va_list args)
{
	jvalue retval;
	Hjava_lang_Object* o = (Hjava_lang_Object*)obj;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_virtual_method_v(m, obj, args, &retval);

	END_EXCEPTION_HANDLING();
	return ((jchar) retval.i);
}

static jchar
JNI_CallCharMethod(JNIEnv* env, jobject obj, jmethodID meth, ...)
{
	va_list args;
	jchar ret;

	BEGIN_EXCEPTION_HANDLING(0);

	va_start(args, meth);
	ret = JNI_CallCharMethodV(env, obj, meth, args);
	va_end(args);

	END_EXCEPTION_HANDLING();
	return (ret);
}

static jchar
JNI_CallCharMethodA(JNIEnv* env, jobject obj, jmethodID meth, jvalue* args)
{
	jvalue retval;
	Hjava_lang_Object* o = (Hjava_lang_Object*)obj;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_virtual_method_a(m, obj, args, &retval);

	END_EXCEPTION_HANDLING();
	return ((jchar) retval.i);
}

static jshort
JNI_CallShortMethodV(JNIEnv* env, jobject obj, jmethodID meth, va_list args)
{
	jvalue retval;
	Hjava_lang_Object* o = (Hjava_lang_Object*)obj;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_virtual_method_v(m, obj, args, &retval);

	END_EXCEPTION_HANDLING();
	return ((jshort) retval.i);
}

static jshort
JNI_CallShortMethod(JNIEnv* env, jobject obj, jmethodID meth, ...) {
	va_list args;
	jshort ret;

	BEGIN_EXCEPTION_HANDLING(0);

	va_start(args, meth);
	ret = JNI_CallShortMethodV(env, obj, meth, args); va_end(args);

	END_EXCEPTION_HANDLING();
	return (ret);
}

static jshort
JNI_CallShortMethodA(JNIEnv* env, jobject obj, jmethodID meth, jvalue* args)
{
	jvalue retval;
	Hjava_lang_Object* o = (Hjava_lang_Object*)obj;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_virtual_method_a(m, obj, args, &retval);

	END_EXCEPTION_HANDLING();
	return ((jshort) retval.i);
}

static jint
JNI_CallIntMethodV(JNIEnv* env, jobject obj, jmethodID meth, va_list args)
{
	jvalue retval;
	Hjava_lang_Object* o = (Hjava_lang_Object*)obj;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_virtual_method_v(m, obj, args, &retval);

	END_EXCEPTION_HANDLING();
	return (retval.i);
}

static jint
JNI_CallIntMethod(JNIEnv* env, jobject obj, jmethodID meth, ...)
{
	va_list args;
	jint ret;

	BEGIN_EXCEPTION_HANDLING(0);

	va_start(args, meth);
	ret = JNI_CallIntMethodV(env, obj, meth, args);
	va_end(args);

	END_EXCEPTION_HANDLING();
	return (ret);
}

static jint
JNI_CallIntMethodA(JNIEnv* env, jobject obj, jmethodID meth, jvalue* args)
{
	jvalue retval;
	Hjava_lang_Object* o = (Hjava_lang_Object*)obj;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_virtual_method_a(m, obj, args, &retval);

	END_EXCEPTION_HANDLING();
	return (retval.i);
}

static jlong
JNI_CallLongMethodV(JNIEnv* env, jobject obj, jmethodID meth, va_list args)
{
	jvalue retval;
	Hjava_lang_Object* o = (Hjava_lang_Object*)obj;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_virtual_method_v(m, obj, args, &retval);

	END_EXCEPTION_HANDLING();
	return (retval.j);
}

static jlong
JNI_CallLongMethod(JNIEnv* env, jobject obj, jmethodID meth, ...)
{
	va_list args;
	jlong ret;

	BEGIN_EXCEPTION_HANDLING(0);

	va_start(args, meth);
	ret = JNI_CallLongMethodV(env, obj, meth, args);
	va_end(args);

	END_EXCEPTION_HANDLING();
	return (ret);
}

static jlong
JNI_CallLongMethodA(JNIEnv* env, jobject obj, jmethodID meth, jvalue* args)
{
	jvalue retval;
	Hjava_lang_Object* o = (Hjava_lang_Object*)obj;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_virtual_method_a(m, obj, args, &retval);

	END_EXCEPTION_HANDLING();
	return (retval.j);
}

static jfloat
JNI_CallFloatMethodV(JNIEnv* env, jobject obj, jmethodID meth, va_list args)
{
	jvalue retval;
	Hjava_lang_Object* o = (Hjava_lang_Object*)obj;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_virtual_method_v(m, obj, args, &retval);

	END_EXCEPTION_HANDLING();
	return (retval.f);
}

static jfloat
JNI_CallFloatMethod(JNIEnv* env, jobject obj, jmethodID meth, ...)
{
	va_list args;
	jfloat ret;

	BEGIN_EXCEPTION_HANDLING(0);

	va_start(args, meth);
	ret = JNI_CallFloatMethodV(env, obj, meth, args);
	va_end(args);

	END_EXCEPTION_HANDLING();
	return (ret);
}

static jfloat
JNI_CallFloatMethodA(JNIEnv* env, jobject obj, jmethodID meth, jvalue* args)
{
	jvalue retval;
	Hjava_lang_Object* o = (Hjava_lang_Object*)obj;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_virtual_method_a(m, obj, args, &retval);

	END_EXCEPTION_HANDLING();
	return (retval.f);
}

static jdouble
JNI_CallDoubleMethodV(JNIEnv* env, jobject obj, jmethodID meth, va_list args)
{
	jvalue retval;
	Hjava_lang_Object* o = (Hjava_lang_Object*)obj;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_virtual_method_v(m, obj, args, &retval);

	END_EXCEPTION_HANDLING();
	return (retval.d);
}

static jdouble
JNI_CallDoubleMethod(JNIEnv* env, jobject obj, jmethodID meth, ...)
{
	va_list args;
	jdouble ret;

	BEGIN_EXCEPTION_HANDLING(0);

	va_start(args, meth);
	ret = JNI_CallDoubleMethodV(env, obj, meth, args);
	va_end(args);

	END_EXCEPTION_HANDLING();
	return (ret);
}

static jdouble
JNI_CallDoubleMethodA(JNIEnv* env, jobject obj, jmethodID meth, jvalue* args)
{
	jvalue retval;
	Hjava_lang_Object* o = (Hjava_lang_Object*)obj;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_virtual_method_a(m, obj, args, &retval);


	END_EXCEPTION_HANDLING();
	return (retval.d);
}

static void
JNI_CallVoidMethodV(JNIEnv* env, jobject obj, jmethodID meth, va_list args)
{
	Hjava_lang_Object* o = (Hjava_lang_Object*)obj;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING_VOID();

	if (METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_virtual_method_v(m, obj, args, NULL);

	END_EXCEPTION_HANDLING();
}

static void
JNI_CallVoidMethod(JNIEnv* env, jobject obj, jmethodID meth, ...)
{
	va_list args;

	BEGIN_EXCEPTION_HANDLING_VOID();

	va_start(args, meth);
	JNI_CallVoidMethodV(env, obj, meth, args);
	va_end(args);

	END_EXCEPTION_HANDLING();
}

static void
JNI_CallVoidMethodA(JNIEnv* env, jobject obj, jmethodID meth, jvalue* args)
{
	Hjava_lang_Object* o = (Hjava_lang_Object*)obj;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING_VOID();

	if (METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_virtual_method_a(m, obj, args, NULL);

	END_EXCEPTION_HANDLING();
}

*/

/* ----------------------------------------------------------------------------
 * Calling Non-virtual Methods
 * --------------------------------------------------------------------------*/

/*
static jobject
JNI_CallNonvirtualObjectMethodV(JNIEnv* env, jobject obj, jclass cls, jmethodID meth, va_list args)
{
	jvalue retval;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_special_method_v(m, cls, obj, args, &retval);

//	ADD_REF(retval.l);
	END_EXCEPTION_HANDLING();
	return (retval.l);
}

static jobject
JNI_CallNonvirtualObjectMethod(JNIEnv* env, jobject obj, jclass cls, jmethodID meth, ...)
{
	va_list args;
	jobject ret;

	BEGIN_EXCEPTION_HANDLING(0);

	va_start(args, meth);
	ret = JNI_CallNonvirtualObjectMethodV(env, obj, cls, meth, args);
	va_end(args);

	END_EXCEPTION_HANDLING();
	return (ret);
}

static jobject
JNI_CallNonvirtualObjectMethodA(JNIEnv* env, jobject obj, jclass cls, jmethodID meth, jvalue* args)
{
	jvalue retval;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_special_method_a(m, cls, obj, args, &retval);

	ADD_REF(retval.l);
	END_EXCEPTION_HANDLING();
	return (retval.l);
}

static jboolean
JNI_CallNonvirtualBooleanMethodV(JNIEnv* env, jobject obj, jclass cls, jmethodID meth, va_list args)
{
	jvalue retval;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_special_method_v(m, cls, obj, args, &retval);

	END_EXCEPTION_HANDLING();
	return ((jboolean) retval.i);
}

static jboolean
JNI_CallNonvirtualBooleanMethod(JNIEnv* env, jobject obj, jclass cls, jmethodID meth, ...)
{
	va_list args;
	jboolean ret;

	BEGIN_EXCEPTION_HANDLING(0);

	va_start(args, meth);
	ret = JNI_CallNonvirtualBooleanMethodV(env, obj, cls, meth, args);
	va_end(args);

	END_EXCEPTION_HANDLING();
	return (ret);
}

static jboolean
JNI_CallNonvirtualBooleanMethodA(JNIEnv* env, jobject obj, jclass cls, jmethodID meth, jvalue* args)
{
	jvalue retval;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_special_method_a(m, cls, obj, args, &retval);

	END_EXCEPTION_HANDLING();
	return ((jboolean) retval.i);
}

static jbyte
JNI_CallNonvirtualByteMethodV(JNIEnv* env, jobject obj, jclass cls, jmethodID meth, va_list args)
{
	jvalue retval;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_special_method_v(m, cls, obj, args, &retval);

	END_EXCEPTION_HANDLING();
	return ((jbyte) retval.i);
}

static jbyte
JNI_CallNonvirtualByteMethod(JNIEnv* env, jobject obj, jclass cls, jmethodID meth, ...)
{
	va_list args;
	jbyte ret;

	BEGIN_EXCEPTION_HANDLING(0);

	va_start(args, meth);
	ret = JNI_CallNonvirtualByteMethodV(env, obj, cls, meth, args);
	va_end(args);

	END_EXCEPTION_HANDLING();
	return (ret);
}

static jbyte
JNI_CallNonvirtualByteMethodA(JNIEnv* env, jobject obj, jclass cls, jmethodID meth, jvalue* args)
{
	jvalue retval;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_special_method_a(m, cls, obj, args, &retval);

	END_EXCEPTION_HANDLING();
	return ((jbyte) retval.i);
}

static jchar
JNI_CallNonvirtualCharMethodV(JNIEnv* env, jobject obj, jclass cls, jmethodID meth, va_list args)
{
	jvalue retval;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_special_method_v(m, cls, obj, args, &retval);

	END_EXCEPTION_HANDLING();
	return ((jchar) retval.i);
}

static jchar
JNI_CallNonvirtualCharMethod(JNIEnv* env, jobject obj, jclass cls, jmethodID meth, ...)
{
	va_list args;
	jchar ret;

	BEGIN_EXCEPTION_HANDLING(0);

	va_start(args, meth);
	ret = JNI_CallNonvirtualCharMethodV(env, obj, cls, meth, args);
	va_end(args);

	END_EXCEPTION_HANDLING();
	return (ret);
}

static jchar
JNI_CallNonvirtualCharMethodA(JNIEnv* env, jobject obj, jclass cls, jmethodID meth, jvalue* args) {
	jvalue retval;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_special_method_a(m, cls, obj, args, &retval);

	END_EXCEPTION_HANDLING();
	return ((jchar) retval.i);
}

static jshort
JNI_CallNonvirtualShortMethodV(JNIEnv* env, jobject obj, jclass cls, jmethodID meth, va_list args)
{
	jvalue retval;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_special_method_v(m, cls, obj, args, &retval);

	END_EXCEPTION_HANDLING();
	return ((jshort) retval.i);
}

static jshort
JNI_CallNonvirtualShortMethod(JNIEnv* env, jobject obj, jclass cls, jmethodID meth, ...)
{
	va_list args;
	jshort ret;

	BEGIN_EXCEPTION_HANDLING(0);

	va_start(args, meth);
	ret = JNI_CallNonvirtualShortMethodV(env, obj, cls, meth, args);
	va_end(args);

	END_EXCEPTION_HANDLING();
	return (ret);
}

static jshort
JNI_CallNonvirtualShortMethodA(JNIEnv* env, jobject obj, jclass cls, jmethodID meth, jvalue* args)
{
	jvalue retval;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_special_method_a(m, cls, obj, args, &retval);
	
	END_EXCEPTION_HANDLING();
	return ((jshort) retval.i);
}

static jint
JNI_CallNonvirtualIntMethodV(JNIEnv* env, jobject obj, jclass cls, jmethodID meth, va_list args)
{
	jvalue retval;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_special_method_v(m, cls, obj, args, &retval);

	END_EXCEPTION_HANDLING();
	return (retval.i);
}

static jint
JNI_CallNonvirtualIntMethod(JNIEnv* env, jobject obj, jclass cls, jmethodID meth, ...)
{
	va_list args;
	jint ret;

	BEGIN_EXCEPTION_HANDLING(0);

	va_start(args, meth);
	ret = JNI_CallNonvirtualIntMethodV(env, obj, cls, meth, args);
	va_end(args);

	END_EXCEPTION_HANDLING();
	return (ret);
}

static jint
JNI_CallNonvirtualIntMethodA(JNIEnv* env, jobject obj, jclass cls, jmethodID meth, jvalue* args)
{
	jvalue retval;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_special_method_a(m, cls, obj, args, &retval);

	END_EXCEPTION_HANDLING();
	return (retval.i);
}

static jlong
JNI_CallNonvirtualLongMethodV(JNIEnv* env, jobject obj, jclass cls, jmethodID meth, va_list args)
{
	jvalue retval;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_special_method_v(m, cls, obj, args, &retval);

	END_EXCEPTION_HANDLING();
	return (retval.j);
}

static jlong
JNI_CallNonvirtualLongMethod(JNIEnv* env, jobject obj, jclass cls, jmethodID meth, ...)
{
	va_list args;
	jlong ret;

	BEGIN_EXCEPTION_HANDLING(0);

	va_start(args, meth);
	ret = JNI_CallNonvirtualLongMethodV(env, obj, cls, meth, args);
	va_end(args);

	END_EXCEPTION_HANDLING();
	return (ret);
}

static jlong
JNI_CallNonvirtualLongMethodA(JNIEnv* env, jobject obj, jclass cls, jmethodID meth, jvalue* args)
{
	jvalue retval;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_special_method_a(m, cls, obj, args, &retval);

	END_EXCEPTION_HANDLING();
	return (retval.j);
}

static jfloat
JNI_CallNonvirtualFloatMethodV(JNIEnv* env, jobject obj, jclass cls, jmethodID meth, va_list args)
{
	jvalue retval;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_special_method_v(m, cls, obj, args, &retval);

	END_EXCEPTION_HANDLING();
	return (retval.f);
}

static jfloat
JNI_CallNonvirtualFloatMethod(JNIEnv* env, jobject obj, jclass cls, jmethodID meth, ...)
{
	va_list args;
	jfloat ret;

	BEGIN_EXCEPTION_HANDLING(0);

	va_start(args, meth);
	ret = JNI_CallNonvirtualFloatMethodV(env, obj, cls, meth, args);
	va_end(args);

	END_EXCEPTION_HANDLING();
	return (ret);
}

static jfloat
JNI_CallNonvirtualFloatMethodA(JNIEnv* env, jobject obj, jclass cls, jmethodID meth, jvalue* args)
{
	jvalue retval;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_special_method_a(m, cls, obj, args, &retval);

	END_EXCEPTION_HANDLING();
	return (retval.f);
}

static jdouble
JNI_CallNonvirtualDoubleMethodV(JNIEnv* env, jobject obj, jclass cls, jmethodID meth, va_list args)
{
	jvalue retval;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_special_method_v(m, cls, obj, args, &retval);

	END_EXCEPTION_HANDLING();
	return (retval.d);
}

static jdouble
JNI_CallNonvirtualDoubleMethod(JNIEnv* env, jobject obj, jclass cls, jmethodID meth, ...)
{
	va_list args;
	jdouble ret;

	BEGIN_EXCEPTION_HANDLING(0);

	va_start(args, meth);
	ret = JNI_CallNonvirtualDoubleMethodV(env, obj, cls, meth, args);
	va_end(args);

	END_EXCEPTION_HANDLING();
	return (ret);
}

static jdouble
JNI_CallNonvirtualDoubleMethodA(JNIEnv* env, jobject obj, jclass cls, jmethodID meth, jvalue* args)
{
	jvalue retval;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_special_method_a(m, cls, obj, args, &retval);

	END_EXCEPTION_HANDLING();
	return (retval.d);
}

static void
JNI_CallNonvirtualVoidMethodV(JNIEnv* env, jobject obj, jclass cls, jmethodID meth, va_list args)
{
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING_VOID();

	if (METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_special_method_v(m, cls, obj, args, NULL);

	END_EXCEPTION_HANDLING();
}

static void
JNI_CallNonvirtualVoidMethod(JNIEnv* env, jobject obj, jclass cls, jmethodID meth, ...)
{
	va_list args;

	BEGIN_EXCEPTION_HANDLING_VOID();

	va_start(args, meth);
	JNI_CallNonvirtualVoidMethodV(env, obj, cls, meth, args);
	va_end(args);

	END_EXCEPTION_HANDLING();
}

static void
JNI_CallNonvirtualVoidMethodA(JNIEnv* env, jobject obj, jclass cls, jmethodID meth, jvalue* args)
{
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING_VOID();

	if (METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_special_method_a(m, cls, obj, args, NULL);

	END_EXCEPTION_HANDLING();
}

*/

/* ----------------------------------------------------------------------------
 * Accessing Fields of Objects
 * --------------------------------------------------------------------------*/

/*
u4 lookup_field(Hjava_lang_Class* cls, utf8* name)
{
	u1* field_name = set_field_name((char*)cls->name->data, (char*)name->data);
	u4 pos = get_field_position(cls->instance_field, field_name);

//	Log("JNI", "!!lookup_field!!\t%s\tpos:%d",(char*)field_name, (int)pos);
	
	gc_free(field_name,0);
	
	return (pos);
}
u4 lookup_static_field(Hjava_lang_Class* cls, utf8* name)
{
	u1* field_name = set_field_name((char*)cls->name->data, (char*)name->data);
	u4 pos = get_field_position(cls->static_field, field_name);

//	Log("JNI", "!!lookup_staticfield!!\t%s\tpos:%d",(char*)field_name, (int)pos);
	gc_free(field_name,0);
	
	return (pos);
}
*/

static jfieldID
JNI_GetFieldID(JNIEnv* env, jclass cls, const char* name, const char* sig)
{
	type_field* field;
	field = findFieldName( cls, loadUtf8(name), loadUtf8(sig) );
	return (field);
}

/*

static jobject
JNI_GetObjectField(JNIEnv* env, jobject obj, jfieldID fld)
{
	jobject nobj;

	BEGIN_EXCEPTION_HANDLING(0);

	nobj = GET_FIELD(jobject, obj, fld);

//	ADD_REF(nobj);
	END_EXCEPTION_HANDLING();
	return (nobj);
}

static jboolean
JNI_GetBooleanField(JNIEnv* env, jobject obj, jfieldID fld)
{
	jboolean ret;

	BEGIN_EXCEPTION_HANDLING(0);

	ret = GET_FIELD(jboolean, obj, fld);

	END_EXCEPTION_HANDLING();
	return (ret);
}

static jbyte
JNI_GetByteField(JNIEnv* env, jobject obj, jfieldID fld)
{
	jbyte ret;
	BEGIN_EXCEPTION_HANDLING(0);

	ret = GET_FIELD(jbyte, obj, fld);

	END_EXCEPTION_HANDLING();
	return (ret);
}

static jchar
JNI_GetCharField(JNIEnv* env, jobject obj, jfieldID fld)
{
	jchar ret;
	BEGIN_EXCEPTION_HANDLING(0);

	ret = GET_FIELD(jchar, obj, fld);

	END_EXCEPTION_HANDLING();
	return (ret);
}

static jshort
JNI_GetShortField(JNIEnv* env, jobject obj, jfieldID fld)
{
	jshort ret;
	BEGIN_EXCEPTION_HANDLING(0);

	ret = GET_FIELD(jshort, obj, fld);

	END_EXCEPTION_HANDLING();
	return (ret);
}
*/

static jint
JNI_GetIntField(JNIEnv* env, jobject obj, jfieldID fld)
{
	jint ret;
	type_field* field = fld;
	ret = *(jint*)(((u1*)((type_object*)obj)->ref)+(int)field->position);
	return (ret);
}

/*
static jlong
JNI_GetLongField(JNIEnv* env, jobject obj, jfieldID fld)
{
	jlong ret;
	BEGIN_EXCEPTION_HANDLING(0);

	ret = GET_FIELD(jlong, obj, fld);

	END_EXCEPTION_HANDLING();
	return (ret);
}

static jfloat
JNI_GetFloatField(JNIEnv* env, jobject obj, jfieldID fld)
{
	jfloat ret;
	BEGIN_EXCEPTION_HANDLING(0);

	ret = GET_FIELD(jfloat, obj, fld);

	END_EXCEPTION_HANDLING();
	return (ret);
}

static jdouble
JNI_GetDoubleField(JNIEnv* env, jobject obj, jfieldID fld)
{
	jdouble ret;
	BEGIN_EXCEPTION_HANDLING(0);

	ret = GET_FIELD(jdouble, obj, fld);

	END_EXCEPTION_HANDLING();
	return (ret);
}

static void
JNI_SetObjectField(JNIEnv* env, jobject obj, jfieldID fld, jobject val)
{
	BEGIN_EXCEPTION_HANDLING_VOID();

	SET_FIELD(jobject, obj, fld, val);

//	Log("JNI", "!!set_O_L_fd!!");
	END_EXCEPTION_HANDLING();
}

static void
JNI_SetBooleanField(JNIEnv* env, jobject obj, jfieldID fld, jbool val)
{
	BEGIN_EXCEPTION_HANDLING_VOID();

	SET_FIELD(jboolean, obj, fld, val);
//	Log("JNI", "!!get_C_L_fd!!\t%x", obj);

	END_EXCEPTION_HANDLING();
}

static void
JNI_SetByteField(JNIEnv* env, jobject obj, jfieldID fld, jbyte val)
{
	BEGIN_EXCEPTION_HANDLING_VOID();

	SET_FIELD(jbyte, obj, fld, val);
//	Log("JNI", "!!get_C_L_fd!!\t%x", obj);

	END_EXCEPTION_HANDLING();
}

static void
JNI_SetCharField(JNIEnv* env, jobject obj, jfieldID fld, jchar val)
{
	BEGIN_EXCEPTION_HANDLING_VOID();

	SET_FIELD(jchar, obj, fld, val);
//	Log("JNI", "!!get_C_L_fd!!\t%x", obj);

	END_EXCEPTION_HANDLING();
}

static void
JNI_SetShortField(JNIEnv* env, jobject obj, jfieldID fld, jshort val)
{
	BEGIN_EXCEPTION_HANDLING_VOID();

	SET_FIELD(jshort, obj, fld, val);
//	Log("JNI", "!!get_C_L_fd!!\t%x", obj);

	END_EXCEPTION_HANDLING();
}

static void
JNI_SetIntField(JNIEnv* env, jobject obj, jfieldID fld, jint val)
{
	BEGIN_EXCEPTION_HANDLING_VOID();

	SET_FIELD(jint, obj, fld, val);
//	Log("JNI", "!!get_C_L_fd!!\t%x", obj);

	END_EXCEPTION_HANDLING();
}

static void
JNI_SetLongField(JNIEnv* env, jobject obj, jfieldID fld, jlong val)
{
	BEGIN_EXCEPTION_HANDLING_VOID();

	SET_FIELD(jlong, obj, fld, val);
//	Log("JNI", "!!set_O_J_fd!!");

	END_EXCEPTION_HANDLING();
}

static void
JNI_SetFloatField(JNIEnv* env, jobject obj, jfieldID fld, jfloat val)
{
	BEGIN_EXCEPTION_HANDLING_VOID();

	SET_FIELD(jfloat, obj, fld, val);

	END_EXCEPTION_HANDLING();
}

static void
JNI_SetDoubleField(JNIEnv* env, jobject obj, jfieldID fld, jdouble val)
{
	BEGIN_EXCEPTION_HANDLING_VOID();

	SET_FIELD(jdouble, obj, fld, val);

	END_EXCEPTION_HANDLING();
}

*/

/* ----------------------------------------------------------------------------
 * Calling Static Methods
 * --------------------------------------------------------------------------*/

static jmethodID
JNI_GetStaticMethodID(JNIEnv* env, jclass cls, const char* name, const char* sig)
{
	type_method_table* method;
	method = findMethodName( cls, loadUtf8(name), loadUtf8(sig) );
	return (method);
}

/*
static jobject
JNI_CallStaticObjectMethodV(JNIEnv* env, jclass cls, jmethodID meth, va_list args)
{
	jvalue retval;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (!METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_static_method_v(m, cls, args, &retval);

//	ADD_REF(retval.l);
	END_EXCEPTION_HANDLING();
	return (retval.l);
}

static jobject
JNI_CallStaticObjectMethod(JNIEnv* env, jclass cls, jmethodID meth, ...)
{
	va_list args;
	jobject ret;

	BEGIN_EXCEPTION_HANDLING(0);

	va_start(args, meth);
	ret = JNI_CallStaticObjectMethodV(env, cls, meth, args);
	va_end(args);

	END_EXCEPTION_HANDLING();
	return (ret);
}

static jobject
JNI_CallStaticObjectMethodA(JNIEnv* env, jclass cls, jmethodID meth, jvalue* args)
{
	jvalue retval;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (!METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_static_method_a(m, cls, args, &retval);

//	ADD_REF(retval.l);
	END_EXCEPTION_HANDLING();
	return (retval.l);
}

static jboolean
JNI_CallStaticBooleanMethodV(JNIEnv* env, jclass cls, jmethodID meth, va_list args)
{
	jvalue retval;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (!METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_static_method_v(m, cls, args, &retval);

	END_EXCEPTION_HANDLING();
	return ((jboolean) retval.i);
}

static jboolean
JNI_CallStaticBooleanMethod(JNIEnv* env, jclass cls, jmethodID meth, ...)
{
	va_list args;
	jboolean ret;

	BEGIN_EXCEPTION_HANDLING(0);

	va_start(args, meth);
	ret = JNI_CallStaticBooleanMethodV(env, cls, meth, args); va_end(args);

	END_EXCEPTION_HANDLING();
	return (ret);
}

static jboolean
JNI_CallStaticBooleanMethodA(JNIEnv* env, jclass cls, jmethodID meth, jvalue* args)
{
	jvalue retval;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (!METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_static_method_a(m, cls, args, &retval);

	END_EXCEPTION_HANDLING();
	return ((jboolean) retval.i);
}

static jbyte
JNI_CallStaticByteMethodV(JNIEnv* env, jclass cls, jmethodID meth, va_list args)
{
	jvalue retval;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (!METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_static_method_v(m, cls, args, &retval);

	END_EXCEPTION_HANDLING();
	return ((jbyte) retval.i);
}

static jbyte
JNI_CallStaticByteMethod(JNIEnv* env, jclass cls, jmethodID meth, ...)
{
	va_list args;
	jbyte ret;

	BEGIN_EXCEPTION_HANDLING(0);

	va_start(args, meth);
	ret = JNI_CallStaticByteMethodV(env, cls, meth, args);
	va_end(args);

	END_EXCEPTION_HANDLING();
	return (ret);
}

static jbyte
JNI_CallStaticByteMethodA(JNIEnv* env, jclass cls, jmethodID meth, jvalue* args)
{
	jvalue retval;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (!METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_static_method_a(m, cls, args, &retval);

	END_EXCEPTION_HANDLING();
	return ((jbyte) retval.i);
}

static jchar
JNI_CallStaticCharMethodV(JNIEnv* env, jclass cls, jmethodID meth, va_list args)
{
	jvalue retval;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (!METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_static_method_v(m, cls, args, &retval);

	END_EXCEPTION_HANDLING();
	return ((jchar) retval.i);
}

static jchar
JNI_CallStaticCharMethod(JNIEnv* env, jclass cls, jmethodID meth, ...)
{
	va_list args;
	jchar ret;

	BEGIN_EXCEPTION_HANDLING(0);

	va_start(args, meth);
	ret = JNI_CallStaticCharMethodV(env, cls, meth, args);
	va_end(args);

	END_EXCEPTION_HANDLING();
	return (ret);
}

static jchar
JNI_CallStaticCharMethodA(JNIEnv* env, jclass cls, jmethodID meth, jvalue* args)
{
	jvalue retval;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (!METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_static_method_a(m, cls, args, &retval);

	END_EXCEPTION_HANDLING();
	return ((jchar) retval.i);
}

static jshort
JNI_CallStaticShortMethodV(JNIEnv* env, jclass cls, jmethodID meth, va_list args)
{
	jvalue retval;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (!METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_static_method_v(m, cls, args, &retval);

	END_EXCEPTION_HANDLING();
	return ((jshort) retval.i);
}

static jshort
JNI_CallStaticShortMethod(JNIEnv* env, jclass cls, jmethodID meth, ...)
{
	va_list args;
	jshort ret;

	BEGIN_EXCEPTION_HANDLING(0);

	va_start(args, meth);
	ret = JNI_CallStaticShortMethodV(env, cls, meth, args);
	va_end(args);

	END_EXCEPTION_HANDLING();
	return (ret);
}

static jshort
JNI_CallStaticShortMethodA(JNIEnv* env, jclass cls, jmethodID meth, jvalue* args)
{
	jvalue retval;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (!METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_static_method_a(m, cls, args, &retval);

	END_EXCEPTION_HANDLING();
	return ((jshort) retval.i);
}

static jint
JNI_CallStaticIntMethodV(JNIEnv* env, jclass cls, jmethodID meth, va_list args)
{
	jvalue retval;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (!METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_static_method_v(m, cls, args, &retval);

	END_EXCEPTION_HANDLING();
	return (retval.i);
}

static jint
JNI_CallStaticIntMethod(JNIEnv* env, jclass cls, jmethodID meth, ...)
{
	va_list args;
	jint ret;

	BEGIN_EXCEPTION_HANDLING(0);

	va_start(args, meth);
	ret = JNI_CallStaticIntMethodV(env, cls, meth, args);
	va_end(args);

	END_EXCEPTION_HANDLING();
	return (ret);
}

static jint
JNI_CallStaticIntMethodA(JNIEnv* env, jclass cls, jmethodID meth, jvalue* args)
{
	jvalue retval;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (!METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_static_method_a(m, cls, args, &retval);

	END_EXCEPTION_HANDLING();
	return (retval.i);
}

static jlong
JNI_CallStaticLongMethodV(JNIEnv* env, jclass cls, jmethodID meth, va_list args)
{
	jvalue retval;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (!METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_static_method_v(m, cls, args, &retval);

	END_EXCEPTION_HANDLING();
	return (retval.j);
}

static jlong
JNI_CallStaticLongMethod(JNIEnv* env, jclass cls, jmethodID meth, ...)
{
	va_list args;
	jlong ret;

	BEGIN_EXCEPTION_HANDLING(0);

	va_start(args, meth);
	ret = JNI_CallStaticLongMethodV(env, cls, meth, args);
	va_end(args);

	END_EXCEPTION_HANDLING();
	return (ret);
}

static jlong
JNI_CallStaticLongMethodA(JNIEnv* env, jclass cls, jmethodID meth, jvalue* args)
{
	jvalue retval;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (!METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_static_method_a(m, cls, args, &retval);

	END_EXCEPTION_HANDLING();
	return (retval.j);
}

static jfloat
JNI_CallStaticFloatMethodV(JNIEnv* env, jclass cls, jmethodID meth, va_list args)
{
	jvalue retval;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (!METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_static_method_v(m, cls, args, &retval);

	END_EXCEPTION_HANDLING();
	return (retval.f);
}

static jfloat
JNI_CallStaticFloatMethod(JNIEnv* env, jclass cls, jmethodID meth, ...)
{
	va_list args;
	jfloat ret;

	BEGIN_EXCEPTION_HANDLING(0);

	va_start(args, meth);
	ret = JNI_CallStaticFloatMethodV(env, cls, meth, args);
	va_end(args);

	END_EXCEPTION_HANDLING();
	return (ret);
}

static jfloat
JNI_CallStaticFloatMethodA(JNIEnv* env, jclass cls, jmethodID meth, jvalue* args)
{
	jvalue retval;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (!METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_static_method_a(m, cls, args, &retval);

	END_EXCEPTION_HANDLING();
	return (retval.f);
}

static jdouble
JNI_CallStaticDoubleMethodV(JNIEnv* env, jclass cls, jmethodID meth, va_list args)
{
	jvalue retval;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (!METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_static_method_v(m, cls, args, &retval);

	END_EXCEPTION_HANDLING();
	return (retval.d);
}

static jdouble
JNI_CallStaticDoubleMethod(JNIEnv* env, jclass cls, jmethodID meth, ...)
{
	va_list args;
	jdouble ret;

	BEGIN_EXCEPTION_HANDLING(0);

	va_start(args, meth);
	ret = JNI_CallStaticDoubleMethodV(env, cls, meth, args);
	va_end(args);

	END_EXCEPTION_HANDLING();
	return (ret);
}

static jdouble
JNI_CallStaticDoubleMethodA(JNIEnv* env, jclass cls, jmethodID meth, jvalue* args)
{
	jvalue retval;
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING(0);

	if (!METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_static_method_a(m, cls, args, &retval);

	END_EXCEPTION_HANDLING();
	return (retval.d);
}

static void
JNI_CallStaticVoidMethodV(JNIEnv* env, jclass cls, jmethodID meth, va_list args)
{
	methods* m = (methods*)meth;

	BEGIN_EXCEPTION_HANDLING_VOID();

	if (!METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_static_method_v(m, cls, args, NULL);

	END_EXCEPTION_HANDLING();
}

static void
JNI_CallStaticVoidMethod(JNIEnv* env, jclass cls, jmethodID meth, ...)
{
	va_list args;

	BEGIN_EXCEPTION_HANDLING_VOID();

	va_start(args, meth);
	JNI_CallStaticVoidMethodV(env, cls, meth, args);
	va_end(args);

	END_EXCEPTION_HANDLING();
}

static void
JNI_CallStaticVoidMethodA(JNIEnv* env, jclass cls, jmethodID meth, jvalue* args)
{
	methods* m = (methods*)meth;

//	BEGIN_EXCEPTION_HANDLING_VOID();

	if (!METHOD_IS_STATIC(m)) {
//		throwException(NoSuchMethodError(m->name->data));
	}

	call_static_method_a(m, cls, args, NULL);

//	END_EXCEPTION_HANDLING();
}

*/

/* ----------------------------------------------------------------------------
 * Accessing Static Fields
 * modified 2004/2/15 by numenor
 * 
 * --------------------------------------------------------------------------*/

static jfieldID
JNI_GetStaticFieldID(JNIEnv* env, jclass cls, const char* name, const char* sig)
{
	type_field* field;
	field = findFieldName( cls, loadUtf8(name), loadUtf8(sig) );
	return (field);
}

/*
static jobject
JNI_GetStaticObjectField(JNIEnv* env, jclass cls, jfieldID fld)
{
	jobject obj;

	BEGIN_EXCEPTION_HANDLING(0);

	obj = GET_STATIC_FIELD(jobject, cls, fld);

//	Log("JNI", "!!get_C_L_fd!!\t%x", obj);
//	ADD_REF(obj);
	END_EXCEPTION_HANDLING();
	return (obj);
}

static jboolean
JNI_GetStaticBooleanField(JNIEnv* env, jclass cls, jfieldID fld)
{
	jboolean ret;
	BEGIN_EXCEPTION_HANDLING(0);

	ret = GET_STATIC_FIELD(jboolean, cls, fld);

	END_EXCEPTION_HANDLING();
	return (ret);
}

static jbyte
JNI_GetStaticByteField(JNIEnv* env, jclass cls, jfieldID fld)
{
	jbyte ret;
	BEGIN_EXCEPTION_HANDLING(0);

	ret = GET_STATIC_FIELD(jbyte, cls, fld);

	END_EXCEPTION_HANDLING();
	return (ret);
}

static jchar
JNI_GetStaticCharField(JNIEnv* env, jclass cls, jfieldID fld)
{
	jchar ret;
	BEGIN_EXCEPTION_HANDLING(0);

	ret = GET_STATIC_FIELD(jchar, cls, fld);

	END_EXCEPTION_HANDLING();
	return (ret);
}

static jshort
JNI_GetStaticShortField(JNIEnv* env, jclass cls, jfieldID fld)
{
	jint ret;
	BEGIN_EXCEPTION_HANDLING(0);

	ret = GET_STATIC_FIELD(jshort, cls, fld);

	END_EXCEPTION_HANDLING();
	return (ret);
}

static jint
JNI_GetStaticIntField(JNIEnv* env, jclass cls, jfieldID fld)
{
	jint ret;
	BEGIN_EXCEPTION_HANDLING(0);

	ret = GET_STATIC_FIELD(jint, cls, fld);

	END_EXCEPTION_HANDLING();
	return (ret);
}

static jlong
JNI_GetStaticLongField(JNIEnv* env, jclass cls, jfieldID fld)
{
	jlong ret;
	BEGIN_EXCEPTION_HANDLING(0);

	ret = GET_STATIC_FIELD(jlong, cls, fld);

	END_EXCEPTION_HANDLING();
	return (ret);
}

static jfloat
JNI_GetStaticFloatField(JNIEnv* env, jclass cls, jfieldID fld)
{
	jfloat ret;
	BEGIN_EXCEPTION_HANDLING(0);

	ret = GET_STATIC_FIELD(jfloat, cls, fld);

	END_EXCEPTION_HANDLING();
	return (ret);
}

static jdouble
JNI_GetStaticDoubleField(JNIEnv* env, jclass cls, jfieldID fld)
{
	jdouble ret;
	BEGIN_EXCEPTION_HANDLING(0);

	ret = GET_STATIC_FIELD(jdouble, cls, fld);

	END_EXCEPTION_HANDLING();
	return (ret);
}
*/

static void
JNI_SetStaticObjectField(JNIEnv* env, jclass cls, jfieldID fld, jobject val)
{
//	BEGIN_EXCEPTION_HANDLING_VOID();

	type_field* field = fld;
	field->size = val;

//	SET_STATIC_FIELD(jobject, cls, fld, val);

//	END_EXCEPTION_HANDLING();
}

/*
static void
JNI_SetStaticBooleanField(JNIEnv* env, jclass cls, jfieldID fld, jbool val)
{
	BEGIN_EXCEPTION_HANDLING_VOID();

	SET_STATIC_FIELD(jboolean, cls, fld, val);

	END_EXCEPTION_HANDLING();
}

static void
JNI_SetStaticByteField(JNIEnv* env, jclass cls, jfieldID fld, jbyte val)
{
	BEGIN_EXCEPTION_HANDLING_VOID();

	SET_STATIC_FIELD(jbyte, cls, fld, val);

	END_EXCEPTION_HANDLING();
}

static void
JNI_SetStaticCharField(JNIEnv* env, jclass cls, jfieldID fld, jchar val)
{
	BEGIN_EXCEPTION_HANDLING_VOID();

	SET_STATIC_FIELD(jchar, cls, fld, val);

	END_EXCEPTION_HANDLING();
}

static void
JNI_SetStaticShortField(JNIEnv* env, jclass cls, jfieldID fld, jshort val)
{
	BEGIN_EXCEPTION_HANDLING_VOID();

	SET_STATIC_FIELD(jshort, cls, fld, val);

	END_EXCEPTION_HANDLING();
}

static void
JNI_SetStaticIntField(JNIEnv* env, jclass cls, jfieldID fld, jint val)
{
	BEGIN_EXCEPTION_HANDLING_VOID();

	SET_STATIC_FIELD(jint, cls, fld, val);

	END_EXCEPTION_HANDLING();
}

static void
JNI_SetStaticLongField(JNIEnv* env, jclass cls, jfieldID fld, jlong val)
{
	BEGIN_EXCEPTION_HANDLING_VOID();

	SET_STATIC_FIELD(jlong, cls, fld, val);

	END_EXCEPTION_HANDLING();
}

static void
JNI_SetStaticFloatField(JNIEnv* env, jclass cls, jfieldID fld, jfloat val)
{
	BEGIN_EXCEPTION_HANDLING_VOID();

	SET_STATIC_FIELD(jfloat, cls, fld, val);

	END_EXCEPTION_HANDLING();
}

static void
JNI_SetStaticDoubleField(JNIEnv* env, jclass cls, jfieldID fld, jdouble val)
{
	BEGIN_EXCEPTION_HANDLING_VOID();

	SET_STATIC_FIELD(jdouble, cls, fld, val);

	END_EXCEPTION_HANDLING();
}

*/

/* ----------------------------------------------------------------------------
 * String Operations
 * --------------------------------------------------------------------------*/


/*
static jstring
JNI_NewString(JNIEnv* env, const jchar* data, jsize len)
{
	jstring* str;
//	void* str;

	printf("NJI NewString\n");
	exit(0);

	BEGIN_EXCEPTION_HANDLING(0);

//	str = (Hjava_lang_String*)newObject(StringClass);
//	str->offset = 0;
//	str->count = len;
//	str->value = (HArrayOfChar*)newArray(TYPE_CLASS(TYPE_Char), len);                   
//	str->interned = 0;
///	str->has = 0;
//	memcpy(STRING_DATA(str), data, len * sizeof(jchar));

	END_EXCEPTION_HANDLING();
	return (str);
}

static jsize
JNI_GetStringLength(JNIEnv* env, jstring data)
{
	jsize ret;

	printf("GetStringLength\n");
	exit(0);

	BEGIN_EXCEPTION_HANDLING(0);

//	ret = ((Hjava_lang_String*)data)->count;
//	ret = STRING_SIZE((Hjava_lang_Object*)data);

	END_EXCEPTION_HANDLING();
	return (ret);
}

static const jchar*
JNI_GetStringChars(JNIEnv* env, jstring data, jboolean* copy)
{
	jchar* ret;

	printf("GetStringChars\n");
	exit(0);

	BEGIN_EXCEPTION_HANDLING(0);

	if (copy != NULL) {
		*copy = JNI_FALSE;
	}

//	ret = STRING_DATA((Hjava_lang_Object*)data);

	END_EXCEPTION_HANDLING();
	return (ret);
}

static void
JNI_ReleaseStringChars(JNIEnv* env, jstring data, const jchar* chars)
{
	printf("ReleaseStringChars\n");
	exit(0);
}

static jstring
JNI_NewStringUTF(JNIEnv* env, const char* data)
{
	Hjava_lang_Object* str;
	utf8* utf8t;
	int len;

//	BEGIN_EXCEPTION_HANDLING(0);

	printf("JNI NewStringUTF\n");

	utf8t = (utf8*)utf8_new((char*)data,strlen(data));
	str = utf8_to_java(utf8t);
	utf8_release(utf8t);
//	errorInfo info;
//	postOutOfMemory(&info);
//	throwError(&info);

//	END_EXCEPTION_HANDLING();
	return (str);
}

// modified 2004.2.7 by numenor
static jsize
JNI_GetStringUTFLength(JNIEnv* env, jstring data)
{
	Hjava_lang_Object* const str = (Hjava_lang_Object*)data;
	jchar* ptr;
	jsize len;
	jsize count;
//	jsize i;

	printf("JNI GetStringUTFLength\n");
	exit(0);
//	BEGIN_EXCEPTION_HANDLING(0);

//	ptr = STRING_DATA(str);
//	len = STRING_SIZE(str);

	// not implements UTF8
	count = len;
//	END_EXCEPTION_HANDLING();
	return (count);
}

static const jbyte*
JNI_GetStringUTFChars(JNIEnv* env, jstring data, jbool* copy)
{
	Hjava_lang_Object* const str = (Hjava_lang_Object*)data;
	jchar* ptr;
	jbyte* buf;
	jsize len;
	jsize i;
	jsize j;

	printf("JNI GetStringUTFChars\n");
	exit(0);

//	BEGIN_EXCEPTION_HANDLING(0);

	if (copy != NULL) {
		*copy = JNI_TRUE;
	}

//	buf = checkPtr(KMALLOC(Kaffe_GetStringUTFLength(env, data) + 1));

//	ptr = STRING_DATA(str);
//	len = STRING_SIZE(str);

	for (j = 0, i = 0; i < len; i++) {
		if (ptr[i] >= 0x0001 && ptr[i] <= 0x007F) {
			buf[j++] = ptr[i] & 0x7F;
		}
		else if (ptr[i] >= 0x0080 && ptr[i] <= 0x07FF) {
			buf[j++] = 0xC0 | ((ptr[i] >> 6) & 0x1F);
			buf[j++] = 0x80 | (ptr[i] & 0x3F);
		}
		else {
			buf[j++] = 0xE0 | ((ptr[i] >> 12) & 0x0F);
			buf[j++] = 0x80 | ((ptr[i] >> 6) & 0x3F);
			buf[j++] = 0x80 | (ptr[i] & 0x3F);
		}
	}

//	END_EXCEPTION_HANDLING();
	return (buf);
}

static void
JNI_ReleaseStringUTFChars(JNIEnv* env, jstring data, const jbyte* chars)
{
//	BEGIN_EXCEPTION_HANDLING_VOID();

	printf("JNI ReleaseString\n");
	exit(0);

//	KFREE(chars);

//	END_EXCEPTION_HANDLING();
}

*/

/* ----------------------------------------------------------------------------
 * Array Operations
 * --------------------------------------------------------------------------*/

#define OBJ_LENGTH(obj)		((obj)->length)
#define UNHAND_ARRAY(arr)	((arr)->data)
#define ARRAY_DATA_OFFSET	((unsigned int)&((HArrayOfObject*)(0)->data))

/*
static jsize
JNI_GetArrayLength(JNIEnv* env, jarray array)
{
	jsize ret;
	BEGIN_EXCEPTION_HANDLING(0);

	ret = obj_length((HArrayOfObject*)array);

	END_EXCEPTION_HANDLING();
	return (ret);
}

static jobjectArray
JNI_NewObjectArray(JNIEnv* env, jsize length, jclass elementClass, jobject initialElement)
{
	HArrayOfObject* obj;
	int i;
	obj = (HArrayOfObject*)new_objarray( (Hjava_lang_Class*)elementClass, (int)length );
	for (i = 0; i < length; i++) 
		unhand_array(obj)[i] = initialElement;
	return (obj);
}

static jobject
JNI_GetObjectArrayElement(JNIEnv* env, jobjectArray array, jsize index)
{
	jobject obj;
	if (index >= obj_length((HArrayOfObject*)array))
		return(0);
	obj = unhand_array((HArrayOfObject*)array)[index];
	return (obj);
}

static void
JNI_SetObjectArrayElement(JNIEnv* env, jobjectArray array, jsize index, jobject value)
{
	if( index >= ((HArrayOfObject*)array)->length )
		return;
	unhand_array((HArrayOfObject*)array)[index] = (Hjava_lang_Object*)value;
}

static jbooleanArray
JNI_NewBooleanArray(JNIEnv* env, jsize length)
{
	jbooleanArray arr;
	arr = new_array( 4, (int)length);
	return (arr);
}

static jbyteArray
JNI_NewByteArray(JNIEnv* env, jsize length)
{
	jbyteArray arr;
	arr = new_array( 8, length);
	return (arr);
}

static jcharArray
JNI_NewCharArray(JNIEnv* env, jsize length)
{
	jcharArray arr;
	arr = new_array( 5, length);
	return (arr);
}

static jshortArray
JNI_NewShortArray(JNIEnv* env, jsize length)
{
	jshortArray arr;
	arr = new_array( 9, length);
	return (arr);
}

static jintArray
JNI_NewIntArray(JNIEnv* env, jsize length)
{
	jintArray arr;
	arr = new_array( 10, length);
	return (arr);
}

static jlongArray
JNI_NewLongArray(JNIEnv* env, jsize length)
{
	jlongArray arr;
	arr = new_array( 11, length);
	return (arr);
}

static jfloatArray
JNI_NewFloatArray(JNIEnv* env, jsize length)
{
	jfloatArray arr;
	arr = new_array( 6, length);
	return (arr);
}

static jdoubleArray
JNI_NewDoubleArray(JNIEnv* env, jsize length)
{
	jdoubleArray arr;
	arr = new_array( 7, length);
	return (arr);
}

static jboolean*
JNI_GetBooleanArrayElements(JNIEnv* env, jbooleanArray array, jbool* isCopy)
{
	jboolean* ret;
	if (isCopy != NULL) {
		*isCopy = JNI_FALSE;
	}
	ret = unhand_array((HArrayOfBoolean*)array);
	return (ret);
}
*/

static jbyte*
JNI_GetByteArrayElements(JNIEnv* env, jbyteArray array, jbool* isCopy)
{
	jbyte* ret;
	if (isCopy != NULL) {
		*isCopy = JNI_FALSE;
	}
	ret = ((type_array*)array)->ref;
	return (ret);
}

/*
static jchar*
JNI_GetCharArrayElements(JNIEnv* env, jcharArray array, jbool* isCopy)
{
	jchar* ret;
	if (isCopy != NULL) {
		*isCopy = JNI_FALSE;
	}
	ret = unhand_array((HArrayOfChar*)array);
	return (ret);
}

static jshort*
JNI_GetShortArrayElements(JNIEnv* env, jshortArray array, jbool* isCopy)
{
	jshort* ret;
	if (isCopy != NULL) {
		*isCopy = JNI_FALSE;
	}
	ret = unhand_array((HArrayOfShort*)array);
	return (ret);
}

static jint*
JNI_GetIntArrayElements(JNIEnv* env, jintArray array, jbool* isCopy)
{
	jint* ret;
	if (isCopy != NULL) {
		*isCopy = JNI_FALSE;
	}
	ret = unhand_array((HArrayOfInt*)array);
	return (ret);
}

static jlong*
JNI_GetLongArrayElements(JNIEnv* env, jlongArray array, jbool* isCopy)
{
	jlong* ret;
	if (isCopy != NULL ) {
		*isCopy = JNI_FALSE;
	}
	ret = unhand_array((HArrayOfLong*)array);
	return (ret);
}

static jfloat*
JNI_GetFloatArrayElements(JNIEnv* env, jfloatArray array, jbool* isCopy)
{
	jfloat* ret;
	if (isCopy != NULL) {
		*isCopy = JNI_FALSE;
	}
	ret = unhand_array((HArrayOfFloat*)array);
	return (ret);
}

static jdouble*
JNI_GetDoubleArrayElements(JNIEnv* env, jdoubleArray array, jbool* isCopy)
{
	jdouble* ret;
	if (isCopy != NULL) {
		*isCopy = JNI_FALSE;
	}
	ret = unhand_array((HArrayOfDouble*)array);
	return (ret);
}

static void
JNI_ReleaseBooleanArrayElements(JNIEnv* env, jbooleanArray array, jbool* elems, jint mode)
{
	BEGIN_EXCEPTION_HANDLING_VOID();

	if (elems != unhand_array((HArrayOfBoolean*)array) )
	{
		switch (mode)
		{
		case JNI_COMMIT:
//			memcpy(	UNHAND_ARRAY((HArrayOfBoolean*)array)->body, elems,
//				OBJE_LENGTH((HArrayOfBoolean*)array) * sizeof(jboolean));
			break;
		case 0:
//			memcpy( UNHAND_ARRAY((HArrayOfBoolean*)array)->body, elems,
//				OBJ_LENGTH((HArrayOfBoolean*)array) * sizeof(jboolean));
//			KFREE(elems);
			break;
		case JNI_ABORT:
//			KFREE(elems);
			break;
		}
	}
	END_EXCEPTION_HANDLING();
}
*/

static void
JNI_ReleaseByteArrayElements(JNIEnv* env, jbyteArray array, jbyte* elems, jint mode)
{
	if( elems != array )
	{
		switch (mode)
	       	{
		case JNI_COMMIT:
//			memcpy(	UNHAND_ARRAY((HArrayOfByte*)array)->body, elems,
//				OBJ_LENGTH((HArrayOfByte*)array) * sizeof(jbyte));
			break;
		case 0:
//			memcpy(	UNHAND_ARRAY((HArrayOfByte*)array)->body, elems,
//				OBJ_LENGTH((HArrayOfByte*)array) * sizeof(jbyte));
//			KFREE(elems);
			break;
		case JNI_ABORT:
//			KFREE(elems);
			break;
		}
	}
}

/*
static void
JNI_ReleaseCharArrayElements(JNIEnv* env, jcharArray array, jchar* elems, jint mode)
{
	BEGIN_EXCEPTION_HANDLING_VOID();

//	if (elems != UNHAND_ARRAY((HArrayOfChar*)array)->body)
	{
		switch (mode)
	       	{
		case JNI_COMMIT:
//			memcpy(	UNHAND_ARRAY((HArrayOfChar*)array)->body, elems,
//				OBJ_LENGTH((HArrayOfChar*)array) * sizeof(jchar));
			break;
		case 0:
//			memcpy(	UNHAND_ARRAY((HArrayOfChar*)array)->body, elems,
//				OBJ_LENGTH((HArrayOfChar*)array) * sizeof(jchar));
//			KFREE(elems);
			break;
		case JNI_ABORT:
//			KFREE(elems);
			break;
		}
	}
	END_EXCEPTION_HANDLING();
}

static void
JNI_ReleaseShortArrayElements(JNIEnv* env, jshortArray array, jshort* elems, jint mode)
{
	BEGIN_EXCEPTION_HANDLING_VOID();

//	if (elems != UNHAND_ARRAY((HArrayOfShort*)array)->body)
       	{
		switch (mode)
	       	{
		case JNI_COMMIT:
//			memcpy(	UNHAND_ARRAY((HArrayOfShort*)array)->body, elems,
//				OBJ_LENGTH((HArrayOfShort*)array) * sizeof(jshort));
			break;
		case 0:
//			memcpy(	UNHAND_ARRAY((HArrayOfShort*)array)->body, elems,
//				OBJ_LENGTH((HArrayOfShort*)array) * sizeof(jshort));
//			KFREE(elems);
			break;
		case JNI_ABORT:
//			KFREE(elems);
			break;
		}
	}
	END_EXCEPTION_HANDLING();
}

static void
JNI_ReleaseIntArrayElements(JNIEnv* env, jintArray array, jint* elems, jint mode)
{
	BEGIN_EXCEPTION_HANDLING_VOID();

//	if (elems != UNHAND_ARRAY((HArrayOfInt*)array)->body)
       	{
		switch (mode)
	       	{
		case JNI_COMMIT:
//			memcpy(	UNHAND_ARRAY((HArrayOfInt*)array)->body, elems,
//				OBJ_LENGTH((HArrayOfInt*)array) * sizeof(jint));
			break;
		case 0:
//			memcpy( UNHAND_ARRAY((HArrayOfInt*)array)->body, elems,
//				OBJ_LENGTH((HArrayOfInt*)array) * sizeof(jint));
//			KFREE(elems);
			break;
		case JNI_ABORT:
//			KFREE(elems);
			break;
		}
	}
	END_EXCEPTION_HANDLING();
}

static void
JNI_ReleaseLongArrayElements(JNIEnv* env, jlongArray array, jlong* elems, jint mode)
{
	BEGIN_EXCEPTION_HANDLING_VOID();

//	if (elems != UNHAND_ARRAY((HArrayOfLong*)array)->body)
       	{
		switch (mode)
	       	{
		case JNI_COMMIT:
//			memcpy(	UNHAND_ARRAY((HArrayOfLong*)array)->body, elems,
//				OBJ_LENGTH((HArrayOfLong*)array) * sizeof(jlong));
			break;
		case 0:
//			memcpy(	UNHAND_ARRAY((HArrayOfLong*)array)->body, elems,
//				OBJ_LENGTH((HArrayOfLong*)array) * sizeof(jlong));
//			KFREE(elems);
			break;
		case JNI_ABORT:
//			KFREE(elems);
			break;
		}
	}
	END_EXCEPTION_HANDLING();
}

static void
JNI_ReleaseFloatArrayElements(JNIEnv* env, jfloatArray array, jfloat* elems, jint mode)
{
	BEGIN_EXCEPTION_HANDLING_VOID();

//	if (elems != UNHAND_ARRAY((HArrayOfFloat*)array)->body)
       	{
		switch (mode)
	       	{
		case JNI_COMMIT:
//			memcpy(	UNHAND_ARRAY((HArrayOfFloat*)array)->body, elems,
//				OBJ_LENGTH((HArrayOfFloat*)array) * sizeof(jfloat));
			break;
		case 0:
//			memcpy(	UNHAND_ARRAY((HArrayOfFloat*)array)->body, elems,
//				OBJ_LENGTH((HArrayOfFloat*)array) * sizeof(jfloat));
//			KFREE(elems);
			break;
		case JNI_ABORT:
//			KFREE(elems);
			break;
		}
	}
	END_EXCEPTION_HANDLING();
}

static void
JNI_ReleaseDoubleArrayElements(JNIEnv* env, jdoubleArray array, jdouble* elems, jint mode)
{
	BEGIN_EXCEPTION_HANDLING_VOID();

//	if (elems != UNHAND_ARRAY((HArrayOfDouble*)array)->body)
       	{
		switch (mode)
	       	{
		case JNI_COMMIT:
//			memcpy(	UNHAND_ARRAY((HArrayOfDouble*)array)->body, elems,
//				OBJ_LENGTH((HArrayOfDouble*)array) * sizeof(jdouble));
			break;
		case 0:
//			memcpy(	UNHAND_ARRAY((HArrayOfDouble*)array)->body, elems,
//				OBJ_LENGTH((HArrayOfDouble*)array) * sizeof(jdouble));
//			KFREE(elems);
			break;
		case JNI_ABORT:
//			KFREE(elems);
			break;
		}
	}
	END_EXCEPTION_HANDLING();
}

static void
JNI_GetBooleanArrayRegion(JNIEnv* env, jbooleanArray array, jsize start, jsize length, jbool* data)
{
	if (start >= obj_length((HArrayOfBoolean*)array) ||
		start + length > obj_length((HArrayOfBoolean*)array))
	{
		return;
//		throwException(ArrayIndexOutOfBoundsException);
	}
	memcpy(data, &unhand_array((HArrayOfBoolean*)array)[start], length * sizeof(jboolean));
}

static void
JNI_GetByteArrayRegion(JNIEnv* env, jbyteArray array, jsize start, jsize length, jbyte* data)
{
	if (start >= obj_length((HArrayOfByte*)array) ||
		start + length > obj_length((HArrayOfByte*)array))
	{
		return;
//		throwException(ArrayIndexOutOfBoundsException);
	}
	memcpy(data, &unhand_array((HArrayOfByte*)array)[start], length * sizeof(jbyte));
}

static void
JNI_GetCharArrayRegion(JNIEnv* env, jcharArray array, jsize start, jsize length, jchar* data)
{
	if (start >= obj_length((HArrayOfChar*)array) ||
		start + length > obj_length((HArrayOfChar*)array))
	{
		return;
//		throwException(ArrayIndexOutOfBoundsException);
	}
	memcpy(data, &unhand_array((HArrayOfChar*)array)[start], length * sizeof(jchar));
}

static void
JNI_GetShortArrayRegion(JNIEnv* env, jshortArray array, jsize start, jsize length, jshort* data)
{
	if (start >= obj_length((HArrayOfShort*)array) ||
		start + length > obj_length((HArrayOfShort*)array))
	{
		return;
//		throwException(ArrayIndexOutOfBoundsException);
	}
	memcpy(data, &unhand_array((HArrayOfShort*)array)[start], length * sizeof(jshort));
}

static void
JNI_GetIntArrayRegion(JNIEnv* env, jintArray array, jsize start, jsize length, jint* data)
{
	if (start >= obj_length((HArrayOfInt*)array) ||
		start + length > obj_length((HArrayOfInt*)array))
	{
		return;
//		throwException(ArrayIndexOutOfBoundsException);
	}
	memcpy(data, &unhand_array((HArrayOfInt*)array)[start], length * sizeof(jint));
}

static void
JNI_GetLongArrayRegion(JNIEnv* env, jlongArray array, jsize start, jsize length, jlong* data)
{
	if (start >= obj_length((HArrayOfLong*)array) ||
		start + length > obj_length((HArrayOfLong*)array))
	{
		return;
//		throwException(ArrayIndexOutOfBoundsException);
	}
	memcpy(data, &unhand_array((HArrayOfLong*)array)[start], length * sizeof(jlong));
}

static void
JNI_GetFloatArrayRegion(JNIEnv* env, jfloatArray array, jsize start, jsize length, jfloat* data)
{
	if (start >= obj_length((HArrayOfFloat*)array) ||
		start + length > obj_length((HArrayOfFloat*)array))
	{
		return;
//		throwException(ArrayIndexOutOfBoundsException);
	}
	memcpy(data, &unhand_array((HArrayOfFloat*)array)[start], length * sizeof(jfloat));
}

static void
JNI_GetDoubleArrayRegion(JNIEnv* env, jdoubleArray array, jsize start, jsize length, jdouble* data)
{
	if (start >= obj_length((HArrayOfDouble*)array) ||
		start + length > obj_length((HArrayOfDouble*)array))
	{
		return;
//		throwException(ArrayIndexOutOfBoundsException);
	}
	memcpy(data, &unhand_array((HArrayOfDouble*)array)[start], length * sizeof(jdouble));
}

//
//
static void
JNI_SetBooleanArrayRegion(JNIEnv* env, jbooleanArray array, jsize start, jsize length, jbool* data)
{
	if (start >= obj_length((HArrayOfBoolean*)array) ||
		start + length > obj_length((HArrayOfBoolean*)array))
	{
		return;
//		throwException(ArrayIndexOutOfBoundsException);
	}
	memcpy(&unhand_array((HArrayOfBoolean*)array)[start], data, length * sizeof(jboolean));
}

static void
JNI_SetByteArrayRegion(JNIEnv* env, jbyteArray array, jsize start, jsize length, jbyte* data)
{
	if (start >= obj_length((HArrayOfByte*)array) ||
		start + length > obj_length((HArrayOfByte*)array))
	{
		return;
//		throwException(ArrayIndexOutOfBoundsException);
	}
	memcpy(&unhand_array((HArrayOfByte*)array)[start], data, length * sizeof(jbyte));
}

static void
JNI_SetCharArrayRegion(JNIEnv* env, jcharArray array, jsize start, jsize length, jchar* data)
{
	if (start >= obj_length((HArrayOfChar*)array) ||
		start + length > obj_length((HArrayOfChar*)array))
	{
		return;
//		throwException(ArrayIndexOutOfBoundsException);
	}
	memcpy(&unhand_array((HArrayOfChar*)array)[start], data, length * sizeof(jchar));
}

static void
JNI_SetShortArrayRegion(JNIEnv* env, jshortArray array, jsize start, jsize length, jshort* data)
{
	if (start >= obj_length((HArrayOfShort*)array) ||
		start + length > obj_length((HArrayOfShort*)array))
	{
		return;
//		throwException(ArrayIndexOutOfBoundsException);
	}
	memcpy(&unhand_array((HArrayOfShort*)array)[start], data, length * sizeof(jshort));
}

static void
JNI_SetIntArrayRegion(JNIEnv* env, jintArray array, jsize start, jsize length, jint* data)
{
	if (start >= obj_length((HArrayOfInt*)array) ||
		start + length > obj_length((HArrayOfInt*)array))
	{
		return;
//		throwException(ArrayIndexOutOfBoundsException);
	}
	memcpy(&unhand_array((HArrayOfInt*)array)[start], data, length * sizeof(jint));
}

static void
JNI_SetLongArrayRegion(JNIEnv* env, jlongArray array, jsize start, jsize length, jlong* data)
{
	if (start >= obj_length((HArrayOfLong*)array) ||
		start + length > obj_length((HArrayOfLong*)array))
	{
		return;
//		throwException(ArrayIndexOutOfBoundsException);
	}
	memcpy(&unhand_array((HArrayOfLong*)array)[start], data, length * sizeof(jlong));
}

static void
JNI_SetFloatArrayRegion(JNIEnv* env, jfloatArray array, jsize start, jsize length, jfloat* data)
{
	if (start >= obj_length((HArrayOfFloat*)array) ||
		start + length > obj_length((HArrayOfFloat*)array))
	{
		return;
//		throwException(ArrayIndexOutOfBoundsException);
	}
	memcpy(&unhand_array((HArrayOfFloat*)array)[start], data, length * sizeof(jfloat));
}

static void
JNI_SetDoubleArrayRegion(JNIEnv* env, jdoubleArray array, jsize start, jsize length, jdouble* data)
{
	if (start >= obj_length((HArrayOfDouble*)array) ||
		start + length > obj_length((HArrayOfDouble*)array))
	{
		return;
//		throwException(ArrayIndexOutOfBoundsException);
	}
	memcpy(&unhand_array((HArrayOfDouble*)array)[start], data, length * sizeof(jdouble));
}

*/

/* ----------------------------------------------------------------------------
 * Registering Native Methods 
 * --------------------------------------------------------------------------*/

/*
static jint
JNI_RegisterNatives(JNIEnv* env, jclass cls, const JNINativeMethod* meths, jint nmethods)
{
//	Method* meth;
	methods* meth;
	int nmeth;
	int i;
	int j;

	BEGIN_EXCEPTION_HANDLING(0);

	// Ŭ ִ ޼ҵ   ̾Ƴ
	// 
	
//	meth = CLASS_METHODS((Hjava_lang_Class*)cls);
//	nmeth = CLASS_NMETHODS((Hjava_lang_Class*)cls);

//	for (j = 0; j < nmethods; j++) {
//		for (i = 0; i < nmeth; i++) {
//			if (strcmp(meth[i].name->data, methods[j].name) == 0 &&
//			    strcmp(METHOD_SIGD(&meth[i]), methods[j].signature) == 0 &&
//			    (meth[i].accflags & ACC_NATIVE) != 0) {
//				Kaffe_JNI_wrapper(&meth[i], methods[j].fnPtr); 
//				goto found;
//			}
//		}
//		throwException(NoSuchMethodError(methods[j].name));

//		found:;
//	}

	END_EXCEPTION_HANDLING();

	return (0);
}

static jint
JNI_UnregisterNatives(JNIEnv* env, jclass cls)
{
	return (-1);
}
*/

/* ----------------------------------------------------------------------------
 * Monitor Operations
 * --------------------------------------------------------------------------*/

/*
static jint
JNI_MonitorEnter(JNIEnv* env, jobject obj)
{
	BEGIN_EXCEPTION_HANDLING(0);

//	lockObject(obj);

	END_EXCEPTION_HANDLING();
	return (0);
}

static jint
JNI_MonitorExit(JNIEnv* env, jobject obj)
{
	BEGIN_EXCEPTION_HANDLING(0);

//	unlockObject(obj);

	END_EXCEPTION_HANDLING();
	return (0);
}

void
JNIExceptionHandler(void)
{
//	vmException* frame;

//	frame = (vmException*)unhand(getCurrentThread())->exceptPtr;
//	if (frame) {
//		JTHREAD_LONGJMP(frame->jbuf, 1);
//	}
}

*/

/* -----------------------------------------------------------------------------
 * Java VM Interface
 * ---------------------------------------------------------------------------*/

/*
static jint
JNI_GetJavaVM(JNIEnv* env, JavaVM** vm)
{
	(*vm) = &jni_JavaVM;
	return (0);
}
*/

/* -----------------------------------------------------------------------------
 * JNIInvokeInterface
 * ---------------------------------------------------------------------------*/

/*
static jint
JNI_DestroyJavaVM(JavaVM* vm)
{
//	exitThread();
	return (0);
}

static jint
JNI_AttachCurrentThread(JavaVM* vm, JNIEnv** p_env, ThreadAttachArgs* thr_args)
{
	(*p_env) = (JNIEnv*)&jni_Env;
	return (0);
}

static jint
JNI_DetachCurrentThread(JavaVM* vm)
{
	return (0);
}
*/

/*
static jint
Kaffe_GetEnv(JavaVM* vm, void** penv, jint interface_id)
{
	JavaVM* currentVM;

	(*penv) = NULL;

	Kaffe_GetJavaVM((JNIEnv*)&Kaffe_JNIEnv, &currentVM);
	if (!Kaffe_IsSameObject((JNIEnv*)&Kaffe_JNIEnv, currentVM, vm))
		return (JNI_EDETACHED);

	switch (interface_id) {
	case JNI_VERSION_1_1:
		(*penv) = (JNIEnv*)&Kaffe_JNIEnv;
		return (JNI_OK);
	case JNI_VERSION_1_2:
		(*penv) = (JNIEnv*)&Kaffe_JNIEnv;
		return (JNI_OK);
#if 0
	case JVMDI_VERSION_1:
		(*penv) = (JVMDI_Interface_1*)&Kaffe_JVMDIEnv;
		return (JNI_OK);
#endif
	default:
		return (JNI_EVERSION);
	}
}
*/

/* -------------------------------------------------------------------------- */

/*
static void
strcatJNI(char* to, const char* from)
{
	char* ptr;

	ptr = &to[strlen(to)];
	for (; *from != 0; from++) {
		switch (*from) {
		case '(':
			break;
		case ')':
			goto end;
		case '_':
			*ptr++ = '_';
			*ptr++ = '1';
			break;
		case ';':
			*ptr++ = '_';
			*ptr++ = '2';
			break;
		case '[':
			*ptr++ = '_';
			*ptr++ = '3';
			break;
		case '/':
			*ptr++ = '_';
			break;
		default:
			*ptr++ = *from;
			break;
		}
	}

	end:;
	*ptr = 0;
}
*/

/*-----------------------------------------------------------------------------
 *
 *---------------------------------------------------------------------------*/

//#if defined(NEED_JNIREFS)
//
/*
static void
addJNIref(jref obj)
{
	jnirefs* table;
	int idx;

//	table = (jnirefs*)unhand(getCurrentThread())->jnireferences;

	if (table->used == JNIREFS) {
		abort();
	}

	idx = table->next;
	for (;;) {
		if (table->objects[idx] == 0) {
			table->objects[idx] = obj;
			table->used++;
			table->next = (idx + 1) % JNIREFS;
			return;
		}
		idx = (idx + 1) % JNIREFS;
	}
}

static void
removeJNIref(jref obj)
{
	int idx;
	jnirefs* table;

//	table = (jnirefs*)unhand(getCurrentThread())->jnireferences;

	for (idx = 0; idx < JNIREFS; idx++) {
		if (table->objects[idx] == obj) {
			table->objects[idx] = 0;
			table->used--;
			return;
		}
	}
}
//#endif

jint
Kaffe_JNI_native(methods* meth)
{
	char name[1024];
	void* func;

//#if defined(NO_SHARED_LIBRARIES)
        strcpy(name, "Java_");
	
//	strcatJNI(name, meth->class->name->data);
//	strcat(name, "_");
//	strcatJNI(name, meth->name->data);

//	func = loadNativeLibrarySym(name);
	if (func == NULL) {
		strcat(name, "__");
//		strcatJNI(name, METHOD_SIGD(meth));
//		func = loadNativeLibrarySym(name);
		if (func == 0) {
			return (JNI_FALSE);
		}
	}

//	Kaffe_JNI_wrapper(meth, func);

	return (JNI_TRUE);
}

*/



struct JNINativeInterface jni_NativeInterface = {

	NULL,
	NULL,
	NULL,
	NULL,
	0,
//	JNI_GetVersion,
	0,
//	JNI_DefineClass,
	JNI_FindClass,
	NULL,
	NULL,
	NULL,
	0,
//	JNI_GetSuperClass,
	0,
//	JNI_IsAssignableFrom,
	NULL,
	0,
//	JNI_Throw,
	0,
//	JNI_ThrowNew,
	JNI_ExceptionOccurred,
	0,
//	JNI_ExceptionDescribe,
	0,
//	JNI_ExceptionClear,
	0,
//	JNI_FatalError,
	NULL,
	NULL,
	0,
//	JNI_NewGlobalRef,
	0,
//	JNI_DeleteGlobalRef,
	0,
//	JNI_DeleteLocalRef,
	0,
//	JNI_IsSameObject,
	NULL,
	NULL,
	0,
//	JNI_AllocObject,
	JNI_NewObject,
	JNI_NewObjectV,
	0,
//	JNI_NewObjectA,
	JNI_GetObjectClass,
	0,
//	JNI_IsInstanceOf,
	JNI_GetMethodID,
	0,
//	JNI_CallObjectMethod,
	0,
//	JNI_CallObjectMethodV,
	0,
//	JNI_CallObjectMethodA,
	0,
//	JNI_CallBooleanMethod,
	0,
//	JNI_CallBooleanMethodV,
	0,
//	JNI_CallBooleanMethodA,
	0,
//	JNI_CallByteMethod,
	0,
//	JNI_CallByteMethodV,
	0,
//	JNI_CallByteMethodA,
	0,
//	JNI_CallCharMethod,
	0,
//	JNI_CallCharMethodV,
	0,
//	JNI_CallCharMethodA,
	0,
//	JNI_CallShortMethod,
	0,
//	JNI_CallShortMethodV,
	0,
//	JNI_CallShortMethodA,
	0,
//	JNI_CallIntMethod,
	0,
//	JNI_CallIntMethodV,
	0,
//	JNI_CallIntMethodA,
	0,
//	JNI_CallLongMethod,
	0,
//	JNI_CallLongMethodV,
	0,
//	JNI_CallLongMethodA,
	0,
//	JNI_CallFloatMethod,
	0,
//	JNI_CallFloatMethodV,
	0,
//	JNI_CallFloatMethodA,
	0,
//	JNI_CallDoubleMethod,
	0,
//	JNI_CallDoubleMethodV,
	0,
//	JNI_CallDoubleMethodA,
	0,
//	JNI_CallVoidMethod,
	0,
//	JNI_CallVoidMethodV,
	0,
//	JNI_CallVoidMethodA,
	0,
//	JNI_CallNonvirtualObjectMethod,
	0,
//	JNI_CallNonvirtualObjectMethodV,
	0,
//	JNI_CallNonvirtualObjectMethodA,
	0,
//	JNI_CallNonvirtualBooleanMethod,
	0,
//	JNI_CallNonvirtualBooleanMethodV,
	0,
//	JNI_CallNonvirtualBooleanMethodA,
	0,
//	JNI_CallNonvirtualByteMethod,
	0,
//	JNI_CallNonvirtualByteMethodV,
	0,
//	JNI_CallNonvirtualByteMethodA,
	0,
//	JNI_CallNonvirtualCharMethod,
	0,
//	JNI_CallNonvirtualCharMethodV,
	0,
//	JNI_CallNonvirtualCharMethodA,
	0,
//	JNI_CallNonvirtualShortMethod,
	0,
//	JNI_CallNonvirtualShortMethodV,
	0,
//	JNI_CallNonvirtualShortMethodA,
	0,
//	JNI_CallNonvirtualIntMethod,
	0,
//	JNI_CallNonvirtualIntMethodV,
	0,
//	JNI_CallNonvirtualIntMethodA,
	0,
//	JNI_CallNonvirtualLongMethod,
	0,
//	JNI_CallNonvirtualLongMethodV,
	0,
//	JNI_CallNonvirtualLongMethodA,
	0,
//	JNI_CallNonvirtualFloatMethod,
	0,
//	JNI_CallNonvirtualFloatMethodV,
	0,
//	JNI_CallNonvirtualFloatMethodA,
	0,
//	JNI_CallNonvirtualDoubleMethod,
	0,
//	JNI_CallNonvirtualDoubleMethodV,
	0,
//	JNI_CallNonvirtualDoubleMethodA,
	0,
//	JNI_CallNonvirtualVoidMethod,
	0,
//	JNI_CallNonvirtualVoidMethodV,
	0,
//	JNI_CallNonvirtualVoidMethodA,
	
	JNI_GetFieldID,
	0,
//	JNI_GetObjectField,
	0,
//	JNI_GetBooleanField,
	0,
//	JNI_GetByteField,
	0,
//	JNI_GetCharField,
	0,
//	JNI_GetShortField,
	JNI_GetIntField,
	0,
//	JNI_GetLongField,
	0,
//	JNI_GetFloatField,
	0,
//	JNI_GetDoubleField,
	0,
//	JNI_SetObjectField,
	0,
//	JNI_SetBooleanField,
	0,
//	JNI_SetByteField,
	0,
//	JNI_SetCharField,
	0,
//	JNI_SetShortField,
	0,
//	JNI_SetIntField,
	0,
//	JNI_SetLongField,
	0,
//	JNI_SetFloatField,
	0,
//	JNI_SetDoubleField,

	0,
	JNI_GetStaticMethodID,
//	JNI_CallStaticObjectMethod,
	0,
//	JNI_CallStaticObjectMethodV,
	0,
//	JNI_CallStaticObjectMethodA,
	0,
//	JNI_CallStaticBooleanMethod,
	0,
//	JNI_CallStaticBooleanMethodV,
	0,
//	JNI_CallStaticBooleanMethodA,
	0,
//	JNI_CallStaticByteMethod,
	0,
//	JNI_CallStaticByteMethodV,
	0,
//	JNI_CallStaticByteMethodA,
	0,
//	JNI_CallStaticCharMethod,
	0,
//	JNI_CallStaticCharMethodV,
	0,
//	JNI_CallStaticCharMethodA,
	0,
//	JNI_CallStaticShortMethod,
	0,
//	JNI_CallStaticShortMethodV,
	0,
//	JNI_CallStaticShortMethodA,
	0,
//	JNI_CallStaticIntMethod,
	0,
//	JNI_CallStaticIntMethodV,
	0,
//	JNI_CallStaticIntMethodA,
	0,
//	JNI_CallStaticLongMethod,
	0,
//	JNI_CallStaticLongMethodV,
	0,
//	JNI_CallStaticLongMethodA,
	0,
//	JNI_CallStaticFloatMethod,
	0,
//	JNI_CallStaticFloatMethodV,
	0,
//	JNI_CallStaticFloatMethodA,
	0,
//	JNI_CallStaticDoubleMethod,
	0,
//	JNI_CallStaticDoubleMethodV,
	0,
//	JNI_CallStaticDoubleMethodA,
	0,
//	JNI_CallStaticVoidMethod,
	0,
//	JNI_CallStaticVoidMethodV,
	0,
//	JNI_CallStaticVoidMethodA,

	JNI_GetStaticFieldID,
	0,
//	JNI_GetStaticObjectField,
	0,
//	JNI_GetStaticBooleanField,
	0,
//	JNI_GetStaticByteField,
	0,
//	JNI_GetStaticCharField,
	0,
//	JNI_GetStaticShortField,
	0,
//	JNI_GetStaticIntField,
	0,
//	JNI_GetStaticLongField,
	0,
//	JNI_GetStaticFloatField,
	0,
//	JNI_GetStaticDoubleField,
	JNI_SetStaticObjectField,
	0,
//	JNI_SetStaticBooleanField,
	0,
//	JNI_SetStaticByteField,
	0,
//	JNI_SetStaticCharField,
	0,
//	JNI_SetStaticShortField,
	0,
//	JNI_SetStaticIntField,
	0,
//	JNI_SetStaticLongField,
	0,
//	JNI_SetStaticFloatField,
	0,
//	JNI_SetStaticDoubleField,

	0,
//	JNI_NewString,
	0,
//	JNI_GetStringLength,
	0,
//	JNI_GetStringChars,
	0,
//	JNI_ReleaseStringChars,
	0,
//	JNI_NewStringUTF,
	0,
//	JNI_GetStringUTFLength,
	0,
//	JNI_GetStringUTFChars,
	0,
//	JNI_ReleaseStringUTFChars,
	0,
//	JNI_GetArrayLength,
	0,
//	JNI_NewObjectArray,
	0,
//	JNI_GetObjectArrayElement,
	0,
//	JNI_SetObjectArrayElement,
	0,
//	JNI_NewBooleanArray,
	0,
//	JNI_NewByteArray,
	0,
//	JNI_NewCharArray,
	0,
//	JNI_NewShortArray,
	0,
//	JNI_NewIntArray,
	0,
//	JNI_NewLongArray,
	0,
//	JNI_NewFloatArray,
	0,
//	JNI_NewDoubleArray,
	0,
//	JNI_GetBooleanArrayElements,
	JNI_GetByteArrayElements,
	0,
//	JNI_GetCharArrayElements,
	0,
//	JNI_GetShortArrayElements,
	0,
//	JNI_GetIntArrayElements,
	0,
//	JNI_GetLongArrayElements,
	0,
//	JNI_GetFloatArrayElements,
	0,
//	JNI_GetDoubleArrayElements,
	0,
//	JNI_ReleaseBooleanArrayElements,
	JNI_ReleaseByteArrayElements,
	0,
//	JNI_ReleaseCharArrayElements,
	0,
//	JNI_ReleaseShortArrayElements,
	0,
//	JNI_ReleaseIntArrayElements,
	0,
//	JNI_ReleaseLongArrayElements,
	0,
//	JNI_ReleaseFloatArrayElements,
	0,
//	JNI_ReleaseDoubleArrayElements,
	0,
//	JNI_GetBooleanArrayRegion,
	0,
//	JNI_GetByteArrayRegion,
	0,
//	JNI_GetCharArrayRegion,
	0,
//     	JNI_GetShortArrayRegion,
	0,
//	JNI_GetIntArrayRegion,
	0,
//	JNI_GetLongArrayRegion,
	0,
//	JNI_GetFloatArrayRegion,
	0,
//	JNI_GetDoubleArrayRegion,
	0,
//	JNI_SetBooleanArrayRegion,
	0,
//	JNI_SetByteArrayRegion,
	0,
//	JNI_SetCharArrayRegion,
	0,
//	JNI_SetShortArrayRegion,
	0,
//	JNI_SetIntArrayRegion,
	0,
//	JNI_SetLongArrayRegion,
	0,
//	JNI_SetFloatArrayRegion,
	0,
//     	JNI_SetDoubleArrayRegion,
	0,
//	JNI_RegisterNatives,
	0,
//	JNI_UnregisterNatives,
	0,
//	JNI_MonitorEnter,
	0,
//	JNI_MonitorExit,
	0
//	JNI_GetJavaVM,

};

/*
 * Setup the Kaffe JNI environment.
 */
struct JNIEnv_ jni_Env = {
	&jni_NativeInterface,
};

/*
 * Setup the Kaffe invoke interface.
 */
struct JNIInvokeInterface jni_InvokeInterface = {
	NULL,
	NULL,
	NULL,
//	JNI_DestroyJavaVM,
//	JNI_AttachCurrentThread,
//	JNI_DetachCurrentThread,
//	Kaffe_GetEnv,
};

/*
 * Setup the Kaffe VM.
 */

JavaVM jni_JavaVM = {
	&jni_InvokeInterface,
};

JavaVMInitArgs jni_JavaVMInitArgs = {
	0,		/* Version */
	0,		/* Properties */
	0,		/* Check source */

	/* you looks a threads.h define */
//	THREADSTACKSIZE,/* Native stack size */
	0,

	0,		/* Java stack size */
	/* you looks a define in gc-incremental.h */

//	MIN_HEAPSIZE,	/* Min heap size */
//	MAX_HEAPSIZE,	/* Max heap size */
	0,0,

	0,		/* Verify mode */
	".",		/* Classpath */
	(void*)&vfprintf,/* Vprintf */
	(void*)&exit,	/* Exit */
//	(void*)&abort,	/* Abort */
	0,

	1,		/* Enable class GC */
	0,		/* Enable verbose GC */
	1,		/* Disable async GC */
	0,		/* Enable verbose class loading */
	0,		/* Enable verbose JIT */
	0,		/* Enable verbose calls */

	/* you looks a define in cg-incremental.h" */
//	ALLOC_HEAPSIZE,	/* Inc heap size */
	0,

	0,		/* Class home */
	0,		/* Library home */
};

/*
 * Array of VMs.
 */
JavaVMInitArgs jni_JavaVMArgs[1];
