#include "pboframe.h"
#include "gc.h"
#include "ee.h"
#include "cl.h"

typedef struct _global_variable
{
	pthread_mutex_t mutex;
	unsigned int	signal_gc;
	unsigned int	signal_cl;
	unsigned int	signal;
	unsigned int	data_global;
	unsigned int	data_local;
	unsigned int	state;

	unsigned int	gc_thread;
	unsigned int	cl_thread;
	unsigned int	ee_thread;
	
	unsigned int	gc_request;
	unsigned int	gc_response;
} global_variable;

void usage( void )
{

}

int main( int argc, char* args[] )
{
	global_variable	var_global;
	gc_t*	gc_local;
	cl_t*	cl_local;
	ee_t*	ee_local;

	pthread_key_create( &spec_key, NULL );
	pthread_mutex_init( &var_global.mutex, 0 );

	memset( &var_global, 0x00, sizeof(global_variable) );
	
	if( argc < 2 )
	{
		usage();
		return 0;
	}

	/* initialize memory manager */
	pbo_t* pboGC = get_gc();
	gc_local = pboGC->local;

	gc_local->gc_thread = &var_global.gc_thread;
//	gc_local->gc_request = &var_global.gc_request;
//	gc_local->gc_response = &var_global.gc_response;
//	gc_local->signal_global	= &var_global.mutex;
//	gc_local->signal_gc	= &var_global.signal_gc;
//	gc_local->signal	= &var_global.signal;
//	gc_local->data_local	= &var_global.data_local;
//	gc_local->data_global	= &var_global.data_global;
//	gc_local->state		= &var_global.state;
	pboframe(pboGC);

	/* initialize class loader */
	pbo_t* pboCL = get_cl();
	cl_local = pboCL->local;

	cl_local->gc_thread = &var_global.gc_thread;
	cl_local->cl_thread = &var_global.cl_thread;
//	cl_local->gc_request = &var_global.gc_request;
//	cl_local->gc_response = &var_global.gc_response;

//	cl_local->signal_global	= &var_global.mutex;
//	cl_local->signal_gc	= &var_global.signal_gc;
//	cl_local->signal_cl	= &var_global.signal_cl;
//	cl_local->signal	= &var_global.signal;
///	cl_local->data_local	= &var_global.data_local;
//	cl_local->data_global	= &var_global.data_global;
//	cl_local->state		= &var_global.state;
	pboframe(pboCL);

	/* initialize scheduler */
//	pbo_t* pboEE = get_ee();
//	ee_local->signal_global	= &var_global.mutex;
//	ee_local->signal_gc	= &var_global.signal_gc;
//	ee_local->signal_cl	= &var_global.signal_cl;
//	ee_local->signal	= &var_global.signal;
//	ee_local->data_a	= &var_global.data_local;
//	ee_local->data_b	= &var_global.data_global;
//	ee_local->state		= &var_global.state;
//	pboframe(pboEE);

	
//	pboframe(pboGC);
//	pboframe(pboCL);
//	pboframe(pboEE);

//	initExecutionEngine();
//	invokeMainMethod( args[1], argc-2, args+2 );
	
//	pthread_join( pboEE->id, NULL );
//	pthread_join( pboCL->id, NULL );
	pthread_join( pboGC->id, NULL );


	printf( "terminated\n");	
	return 0;
}
