#include "jtypes.h"
#include "type.h"

#include <dlfcn.h>
#include <ltdl.h>


#include "native.h"
#include "memory.h"

struct handles
{
	lt_dlhandle lib;
	char* name;
} hlib[20];

int maxnlib = 0;



void invokeNativeMethod(void *func, int psize, int *param, char rtype, jvalue *ret)
{
	int i = psize;

	while( i > 0 )

	__asm__ __volatile__ ("pushl %0" : : "m" (*((u4*)param+(--i))) : "sp" );

	switch( rtype )
	{
		
	case 'V':
		
		((void (*)(void))(func))();
		break;

	case 'D':
		
		ret->d = ((jdouble (*)(void))(func))();
		break;

	case 'F':
		
   		ret->f = ((jfloat (*)(void))(func))();
		break;

	case 'J':

		ret->j = ((jlong (*)(void))(func))();
		break;
		
	default:
		
		ret->i = ((u4 (*)(void))(func))();
		break;
	}
	
	__asm__ __volatile__ ("addl %0,%%esp" : : "r" (psize*sizeof(u4)) : "cc", "sp" );
}

void initNative()
{

        lt_dlinit();
        maxnlib = 20;
        memset( hlib, 0, sizeof(hlib) );
        loadNative("./libjvmjni.so");
}

void finalNative()
{
        int i;

        for( i = 0 ; i < maxnlib ; i++ )
        {
        }
        lt_dlexit();
}

bool loadNative(char* c)
{
        int i;
        char* name;
        lt_dlhandle handle;


	name = loadUtf8( c );

        for( i = 0 ; i < maxnlib ; i++ )
        {
                if( hlib[i].name == 0 )
                      break;
                if( strcmp( hlib[i].name, name ) == 0 )
                      return (1);
        }

        handle = lt_dlopenext( name );

        if( handle == NULL )
        {
                printf("%s\n",(char*)lt_dlerror());
                exit(0);
        }

        for( i = 0 ; i < maxnlib ; i++ )
        {
                if( hlib[i].name == NULL )
                {
                        hlib[i].lib = handle;
                        hlib[i].name = malloc( strlen(name)+1, 0 );
                        strcpy( hlib[i].name, name );
                        return (1);
                }
        }
        return (0);
}

lt_ptr findNative(char* c)
{
        int i;
        char* name;
        lt_ptr sym;

	name = loadUtf8( c );
        i = 0;
        sym = 0;

        while( !sym && i < maxnlib )
        {
                if( hlib[i].name != NULL )
                        sym = lt_dlsym( hlib[i].lib, name );
                i++;
        }
        return (sym);
}

