#include "jtypes.h"
#include "type.h"

#include "object.h"
#include "memory.h"

//
//
u1* string_boolean;
u1* string_byte;
u1* string_short;
u1* string_int;
u1* string_long;
u1* string_float;
u1* string_double;
u1* string_char;


void initConstructor(void)
{
//	variable = findFieldName( class, interUTF8new("value"), interUTF8new("[C"));
//	0 - 4	
//	variable = findFieldName( class, interUTF8new("count"), interUTF8new("I"));
//	4 - 4	
	return;
}


type_object* newObject( type_class* class )
{
	type_object* object;

	// if class is string, go newString

	if( strcmp( class->name, "java/lang/Class" ) == 0 )
	{
		printf("class object create?\n");
		exit(0);
	}
	if( strcmp( class->name, "java/lang/ClassLoader" ) == 0 )
	{
		printf("class loader object create?\n");
		exit(0);
	}
	if( strcmp( class->name, "java/lang/String" ) == 0 )
	{
		printf("string object create?\n");
//		exit(0);
//		return newString( 0 );
	}

	
	// 1st condition for ACTIVE USE
	if( class->state != CLASSSTATE_COMPLETED )
		initClass( class, 0 );
	
	object = allocateMemory( sizeof(type_object) + class->intsize );

	object->cls = class;
	object->ref = &object[1];
		
	return (object);
}


type_object* newClass( type_class* class )
{
	return (0);
}


type_object* newString( u1* str )
{
	type_object* object;
	type_array* array;
	type_class* class;
	u1* tmp;
	jchar* ustr;
	unsigned int length;

	
	tmp = loadUtf8( "java/lang/String" );
	class = cload( tmp, 0 );

	// create a string object
	
	object = allocateMemory( sizeof(type_object) + class->intsize );
	object->cls = class;
	object->ref = &object[1];

	// create a value of string object

	if( str != 0 )
	{
	
		length = getUnicodeLength( str );
		array = newArray( 5, length );
		convertUnicode( str, array->ref, length );
		*(u4*)object->ref =  array;
		*((u4*)object->ref+1) = array->length;
		object = internString( object );

//		printf( "%x str=%s,length=%d\n", object, str, array->length );	

	}

	return (object);
}


type_object* newArray( u4 atype, u4 count )
{
	type_class* class;
	type_array* array;


	switch( atype )
	{
	case 4: // T_BOOLEAN
		
		class = cload( loadUtf8("[Z") , 0);
		array = allocateMemory( sizeof(type_array) + sizeof(jboolean)*count );
		array->tsize = sizeof(jboolean);
		break;

	case 5: // T_CHAR

		class = cload( loadUtf8("[C"), 0);
		array = allocateMemory( sizeof(type_array) + sizeof(jchar)*count );
		array->tsize = sizeof(jchar);
		break;

	case 6: // T_FLOAT

		class = cload( loadUtf8("[F"), 0);
		array = allocateMemory( sizeof(type_array) + sizeof(jfloat)*count );
		array->tsize = sizeof(jfloat);
		break;

	case 7: // T_DOUBLE

		class = cload( loadUtf8("[D"), 0);
		array = allocateMemory( sizeof(type_array) + sizeof(jdouble)*count );
		array->tsize = sizeof(jdouble);
		break;

	case 8: // T_BYTE

		class = cload( loadUtf8("[B"), 0);
		array = allocateMemory( sizeof(type_array) + sizeof(jbyte)*count );
		array->tsize = sizeof(jbyte);
		break;

	case 9: // T_SHORT

		class = cload( loadUtf8("[S"), 0);
		array = allocateMemory( sizeof(type_array) + sizeof(jshort)*count );
		array->tsize = sizeof(jshort);
		break;
	
	case 10: // T_INT

		class = cload( loadUtf8("[I"), 0);
		array = allocateMemory( sizeof(type_array) + sizeof(jint)*count );
		array->tsize = sizeof(jint);
		break;
	
	case 11: // T_LONG

		class = cload( loadUtf8("[J"), 0);
		array = allocateMemory( sizeof(type_array) + sizeof(jlong)*count );
		array->tsize = sizeof(jlong);
		break;
	
	default:
		
		printf("array error\n");
		exit(0);
		break;

	}

	array->cls = class;
	array->ref = &array[1];
	array->length = count;
//	array->tsize;

	return(array);
}


type_object* newObjectArray( type_class* class, u4 count )
{
	type_class*	acls;
	type_array*	array;
	char *name;

	
	if( class->name[0] == '[' )
	{
		name = malloc( sizeof(char)*strlen(class->name)+2 );
		strcpy(name,"[");
		strcat(name,class->name);
	}
	else
	{
		name = malloc( sizeof(char)*strlen(class->name)+4 );
		strcpy(name,"[L");
		strcat(name,class->name);
		strcat(name,";");
	}

	name = loadUtf8( name );

	acls = cload(name, 0);
	array = allocateMemory( sizeof(type_array) + sizeof(jref)*count );

	array->cls = acls;
	array->ref = &array[1];
	array->length = count;
	array->tsize = sizeof(jobject);
		
	return (array);
}


void copyArray
( type_array* src_array, int src_offset, type_array* dst_array, int dst_offset, int length )
{
	unsigned char* src = src_array->ref;
	unsigned char* dst = dst_array->ref;
	unsigned char* tmp;
	unsigned int step;

	int i;

	
	if( src_array->tsize != dst_array->tsize )
		exit(0);

	step = src_array->tsize;
	tmp = malloc( src_array->tsize * (length+1) );
	memcpy( tmp, src + ( step*src_offset ), ( step*length ) );
	memcpy( dst + ( step*dst_offset ), tmp, step*length );

	/* debug
  	for( i = 0 ; i < src_array->length ; i++ )
   		printf("%c", ((jchar*)src)[i] );
  	printf(" -> ");
     	for( i = 0 ; i < dst_array->length ; i++ )
       		printf("%c", ((jchar*)dst)[i] );
  	printf("\n");
	/* debug */

	return;
}


int instanceOf( type_class* class, type_class* object_class )
{
	type_class* interface;
	int count;

	while( object_class != 0 )
	{
		if( object_class == class )
			return (1);
		count = object_class->ninterface;

		while( count > 0 )
		{
			if( object_class->interfaces[count] == class )
				return (1);
			count--;
		}

		object_class = object_class->super;
	}
	
	return (0);
}
