#ifndef __PBO_H
#define __PBO_H

#include <pthread.h>

typedef int(*pboFunc_f)(void*);

typedef struct _pboFunc_t {
	pboFunc_f	init;
//	pboFunc_f	reint;
//	pboFunc_f	on;
	pboFunc_f	cycle;
//	pboFunc_f	sync;
//	pboFunc_f	off;
	pboFunc_f	term;
} pboFunc_t;

pthread_key_t spec_key;

typedef struct _pbo_t {
	int state;
	pboFunc_t* func;
	void* local;
	void* thread;

	
	pthread_t id;
	pthread_mutex_t mutex;
	pthread_cond_t cond;

} pbo_t;

#define PBO_OK		0
#define PBO_NOTCREATED	1
#define PBO_OFF		2
#define PBO_ON		3
#define PBO_KILL 	4

//	typedef void xyz##_t;

#define PBO_MODULE(xyz)				\
	typedef int(*xyz##Func_f)(xyz##_t *);	\
						\
	int xyz##Init(pbo_t*);			\
	int xyz##Reinit(xyz##_t*);		\
	int xyz##On(xyz##_t*);			\
	int xyz##Cycle(xyz##_t*);		\
	int xyz##Sync(xyz##_t*);		\
	int xyz##Off(xyz##_t*);			\
	int xyz##Term(xyz##_t*);		\
						\
	typedef struct xyz##Func_t {		\
		xyz##Func_f	init;		\
		xyz##Func_f	cycle;		\
		xyz##Func_f	term;		\
	} xyz##Func_t;				\
						\
	const xyz##Func_t xyz##Func = {		\
		xyz##Init,			\
		xyz##Cycle,			\
		xyz##Term			\
	};					\

#endif

