#include <pthread.h>
#include "pboframe.h"
#include "thread.h"


nthread_t* temp;

void* process( void* p ) {

	pbo_t* pbo = p;

	pbo->state = PBO_NOTCREATED;

	while(1)
	{
//		printf("[1] pbo {%x} / state {%d}\n", pbo, pbo->state );

		switch( pbo->state )
		{
		case PBO_NOTCREATED:

			// initialize native thread //
			pbo->thread = initNthread();
			
//			pthread_setspecific( spec_key, pbo );

			pbo->func->init( pbo );
			pbo->state = PBO_ON;

			break;

		case PBO_ON:

//			printf("wait request\n");
			waitRequest( pbo->thread );
			pbo->func->cycle( pbo->local );
//			printf("response\n");
			response( pbo->thread );

			break;
			

		case PBO_KILL:

			pthread_exit(0);

			break;

		default:
			break;
		}
	}
		
	return (pbo);
}

int pboframe( pbo_t* pbo ) {

	pthread_create( &pbo->id, NULL, process, pbo );
	return 0;
}
