
// Type Defination.

#ifndef _DEFINE_H_
#define _DEFINE_H_

///////////////////////////////
/* class format version info */
///////////////////////////////

#define JAVAMAGIC       0xCafeBabe
#define MAJOR_VERSION   45
#define MINOR_VERSION   3

/////////////////////
/* unit data block */
/////////////////////

typedef	unsigned char	block8;
typedef	unsigned short	block16;
typedef	unsigned int	block32;
typedef	unsigned long   block64;

typedef	block8	u1;
typedef	block16	u2;
typedef	block32	u4;
typedef	block64	u8;

// additional gtypes
typedef u1	uint8;
typedef u2	uint16;
typedef u4	uint32;
typedef u8	uint64;
typedef signed char	int8;
typedef signed short	int16;
typedef	signed int	int32;
typedef signed long	int64;
typedef uint32	uintp;

typedef	u1	nativecode;
typedef	u2	accessFlags;
typedef	u2	constIndex;

///////////////
/* base type */
///////////////

// B	: byte
// C	: char
// D	: double
// F	: float
// I	: int
// J	: long
// S	: short
// Z	: boolean


//////////////////
/* class status */
//////////////////

#define	CLASS_UNLOADED			0
#define	CLASS_LOADED			1
#define	CLASS_PRELOADED			2
#define	CLASS_DOING_PREPARE		3
#define	CLASS_PREPARED			4
#define	CLASS_LINKED			5
#define	CLASS_CONSTINIT			6
#define	CLASS_DOING_SUPER		7
#define	CLASS_USABLE			8
#define	CLASS_DOING_INIT		9
#define	CLASS_INIT_FAILED		10
#define	CLASS_COMPLETE			11
#define	CLASS_FAILED			-1

////////////////////////
/* constant pool type */
////////////////////////

#define	Constant_Unknown				0
#define Constant_Error                  0
#define	Constant_Utf8					1
#define	Constant_Int					3
#define	Constant_Float					4
#define	Constant_Long					5
#define	Constant_Double					6
#define	Constant_Class					7
#define	Constant_String					8
#define	Constant_FieldRef				9
#define	Constant_MethodRef				10
#define	Constant_Interface_MethodRef	11
#define	Constant_Name_and_Type			12

//////////////////
/* access flags */
//////////////////

#define	ACC_PUBLIC			0x0001
#define	ACC_PRIVATE			0x0002
#define	ACC_PROTECTED		0x0004
#define	ACC_STATIC			0x0008
#define	ACC_FINAL			0x0010
#define	ACC_SYNCHRONIZED	0x0020
#define	ACC_VOLATILE		0x0040
#define	ACC_TRANSIENT		0x0080
#define	ACC_NATIVE			0x0100
#define	ACC_INTERFACE		0x0200
#define	ACC_ABSTRACT		0x0400
#define	ACC_STRICT			0x0800

// attribute flag

#define FIELD_ATTR			0X0000001
#define METHOD_ATTR			0X0000002
#define CLASS_ATTR			0x0000003
#define CODE_ATTR	        0X0000004
#define DEFAULT				0x0000005


// attribute tag 

#define CODE				1	
#define EXCEPTION			2
#define SOURCEFILE			3
#define INNERCLASS			4
#define LINE_NUM			5
#define LOCAL_VAR			6
/////////////////////
/* base type	   */
/////////////////////

typedef u4 BOOL;

#define TRUE  1
#define FALSE 0

/////////////////////
/* array type	   */
/////////////////////

#define T_BOOLEAN  4  
#define T_CHAR     5  
#define T_FLOAT    6  
#define T_DOUBLE   7  
#define T_BYTE     8  
#define T_SHORT    9  
#define T_INT      10  
#define T_LONG     11  

/////////////////////
/* typedef          */
/////////////////////]
typedef struct class_file_struct				 class_file;

typedef struct class_list_struct				 class_list;

typedef struct classpath_list_struct			 classpath_list;

typedef struct constant_pool_struct				 constant_pool;

typedef struct field_info_struct				 field_info;

typedef struct fields_struct					 fields;

/* */
typedef struct Hjava_lang_Object_struct		Hjava_lang_Object;
typedef struct Hjava_lang_Class_struct		Hjava_lang_Class;
typedef struct Hjava_lang_ClassLoader_struct	Hjava_lang_ClassLoader;
//typedef struct Hjava_lang_Thread_struct		Hjava_lang_Thread;
typedef struct method_info_struct		method_info;
typedef struct methods_struct			methods;
typedef struct utf8_struct			utf8;
typedef struct attributes_constant_value_struct	attri_constant;
typedef struct attri_line_number_table_struct	attri_line_number;
typedef struct attri_code_struct		attri_code;
typedef struct attri_local_variable_table_struct	attri_local_variable;
typedef struct exception_table_struct		exception_table;
typedef struct line_number_info_struct		line_number_info;
typedef struct attri_exception_struct		attri_exception;
typedef struct attri_sourcefile_struct		attri_sourcefile;
typedef struct local_variable_info_struct	local_variable_info;
typedef struct attri_innerclass_struct		attri_innerclass;
typedef struct innerclass_table			innerclass_table;
typedef struct _jar				jar;
typedef	struct _jFILE				jFILE;
typedef	struct attr_in_code_struct		attr_in_code;
typedef struct attr_in_method_struct		attr_in_method;
typedef struct attribute_struct			attribute;
typedef struct _runnable			runnable;
typedef struct field_alloc_struct		field_alloc;
typedef struct field_list_struct		field_list;
typedef struct runnable_mapping_struct		runnable_mapping_table;
#endif
