#include <sys/utsname.h>
//#include <stdlib.h>
#include "jtypes.h"
#include "type.h"
#include <pthread.h>


#include "memory.h"

// ============================================================================
// VM Class
// ============================================================================


jboolean Java_java_lang_VMClass_isPrimitive__Ljava_lang_Class_2
(void *env, jclass c1, jclass c2)
{
	char *c = ((type_class*)c2)->name;

	if( c[1] != '\0' )
	{
		if( *c == '[' ) 
			return (1);
		else
			return (0);
	}

	if(	( *c == 'Z' ) || ( *c == 'B' ) || ( *c == 'C' ) ||
		( *c == 'S' ) || ( *c == 'I' ) || ( *c == 'J' ) ||
		( *c == 'F' ) || ( *c == 'D' ) || ( *c == 'V' ) )
		return (1);
	else
		exit(0);
}


jclass Java_java_lang_VMClass_forName__Ljava_lang_String_2
(void* env, jclass cls, jstring str)
{
	printf("for name\n");
	return (findClass(str));
}


jobject Java_java_lang_VMClass_getClassLoader__Ljava_lang_Class_2
(void* env, jclass c1, jclass c2)
{
	type_loader* loader = ((type_class*)c2)->loader;

	if( loader == 0 )
	{
		printf( "loader is null\n" );
		exit(0);
	}	
	return ( loader );
}


jstring Java_java_lang_VMClass_getName__Ljava_lang_Class_2
(void* env, jclass c1, jclass c2)
{
	type_class* class = c2;
	type_object* result = newString( class->name );
	return (result);
}


jarray Java_java_lang_VMClass_getInterfaces__Ljava_lang_Class_2
(void* env, jclass c1, jclass c2)
{
	type_class* interfaces = c2;
	type_class* class;
	type_array* array;
	int count;

	
	if( c2 == 0 ) return 0;
	count = interfaces->ninterface;

	class = cload( loadUtf8("java/lang/Class"), 0 );
	array = newObjectArray( class, count );

	while( count > 0 )
	{
		count--;
		((u4*)array->ref)[count] = interfaces->interfaces[count];
	}
	
	return (array);
}


jobjectArray
Java_java_lang_VMClass_getDeclaredConstructors__Ljava_lang_Class_2Z
(void* env, jclass c, jobject o, jboolean b)
{
	type_class* constructor;
	type_class* class = o;
	type_object* ele;
	type_array* result;
	type_method_table* method;
	type_field* field;
	
	int count = 0;
	int i,j;
	int pos;
	
	constructor = cload( loadUtf8("java/lang/reflect/Constructor"), 0 );


	printf( "%s \n", class->name );
	
	method = class->methods;

	for( i = 0 ; i < class->nmethod ; i++ )
	{
		if( ( strcmp( "<init>", method[i].name ) == 0 ) &&
			( !b || method[i].flag & ACC_PUBLIC ) )
			count++;
	}

//	printf("\t constructor counter = %d\n", count );
	
	result = newObjectArray( constructor, count );
	
	for( i = 0, j = 0 ; j < count ; i++ )
	{
		if( ( strcmp( "<init>", method[i].name ) == 0 ) &&
			( !b || method[i].flag & ACC_PUBLIC ) )
		{
			ele = newObject( constructor );

			field = findFieldName( constructor,
				loadUtf8("clazz"),
			       	loadUtf8("Ljava/lang/Class;") );

			((u4*)ele->ref)[field->position/4] = class;
			
			field = findFieldName( constructor,
				loadUtf8("slot"), loadUtf8("I") );

			((u4*)ele->ref)[field->position/4] = i;

			field = findFieldName( constructor,
				loadUtf8("parameterTypes"),
			       	loadUtf8("[Ljava/lang/Class;") );

			((u4*)ele->ref)[field->position/4] =
				convertParameters( method[i].descriptor, 0 );

			((u4*)result->ref)[j] = ele;
			j++;

//			printf("\t-name %d {%s}\n", i, method[i].descriptor );
		}
	}

	return (result);
}


// ============================================================================
// VM Class Loader
// ============================================================================

jclass* Java_java_lang_VMClassLoader_getPrimitiveClass__C
(void* env, jclass cls, jchar c)
{
	type_class* class = 0;
	
	switch( c )
	{
	case 'Z':
		class = cload( loadUtf8("Z"), 0 );
		break;
	case 'B':
		class = cload( loadUtf8("B"), 0 );
		break;
	case 'C':
		class = cload( loadUtf8("C"), 0 );
		break;
	case 'D':
		class = cload( loadUtf8("D"), 0 );
		break;
	case 'F':
		class = cload( loadUtf8("F"), 0 );
		break;
	case 'I':
		class = cload( loadUtf8("I"), 0 );
		break;
	case 'J':
		class = cload( loadUtf8("J"), 0 );
		break;
	case 'S':
		class = cload( loadUtf8("S"), 0 );
		break;
	case 'V':
		class = cload( loadUtf8("V"), 0 );
		break;
	default:
		exit(0);
		break;
	}

	return( class );
}


jclass* Java_java_lang_VMClassLoader_loadClass__Ljava_lang_String_2Z
(void* env, jclass cls, jstring s, jboolean b)
{
	type_array* array = *(u4*)((type_object*)((type_object*)s)->ref);
	char* uch = convertUtf8( array->ref, array->length );
	u1* tmp;
	type_class* class;
	
	for( tmp = uch ; *tmp != '\0' ; tmp++ )
	{
		if( *tmp == '.' ) *tmp = '/';
	}

	tmp = loadUtf8( uch );
	class = cload( tmp, 0 );
	return (class);
}


jclass* Java_java_lang_VMClassLoader_findLoadedClass__Ljava_lang_ClassLoader_2Ljava_lang_String_2
(void* env, jclass cls, jobject o, jstring s)
{
	type_loader* loader = o;
	type_array* array = *(u4*)((type_object*)((type_object*)s)->ref);
	char* uch = convertUtf8( array->ref, array->length );
	u1* tmp;
	type_class* class;
	
	for( tmp = uch ; *tmp != '\0' ; tmp++ )
	{
		if( *tmp == '.' ) *tmp = '/';
	}

	tmp = loadUtf8( uch );
	class = findFromList( tmp, loader );
	return (class);
}

// ============================================================================
// java lang reflect Constructor
// ============================================================================

jobject
Java_java_lang_reflect_Constructor_constructNative___3Ljava_lang_Object_2Ljava_lang_Class_2I
(void* env, jobject o, jobjectArray a, jclass c, jint bb)
{

	type_class* class = c;
	type_object* object = newObject( class );
	type_method_table* method = class->methods;
	type_frame* frame;
	type_array* args = a;
	int count;
	int i;


	method = &method[bb];
	count = method->parsize;

	frame = malloc( sizeof(type_frame) + sizeof(u4)*count );

	frame->stack = &frame[1];
	frame->tos = frame->stack;
	*((u4*)frame->tos) = object;
	for( i = 1 ; args != 0 && i < count ; i++ )
	{
		frame->tos++;
		*(frame->tos) = ((u4*)args->ref)[i-1];
	}
	invokeMethod( method, frame );

//	free( frame );
	return (object);
}

jint Java_java_lang_reflect_Constructor_getModifiers
(void *env, jobject o)
{
	type_class* cls = ((type_object*)o)->cls;
	return ( cls->acc_flag );
}


// ============================================================================
// VM Object
// ============================================================================


jobject Java_java_lang_VMObject_clone__Ljava_lang_Cloneable_2
(void* env, jclass cls, jobject obj)
{
	type_class* class;
	type_object* clone;
	int size;


	class = ((type_object*)obj)->cls;
	clone = newObject( class );
	size = class->intsize;
	memcpy( clone->ref, ((type_object*)obj)->ref, size );
	return (clone);
}


// ============================================================================
// VM Runtime
// ============================================================================


void setProperty(jobject obj, char *key, char *value )
{
	type_object* prop = (type_object*)obj;
	type_class* class = prop->cls;
	type_object* skey = newString( loadUtf8(key) );
	type_object* sval = newString( loadUtf8(value) );
	type_method_table* method;

	u1* name = loadUtf8( "setProperty" );
	u1* descriptor = loadUtf8(
		"(Ljava/lang/String;Ljava/lang/String;)Ljava/lang/Object;");

	if( ( method = findMethodName( class, name, descriptor ) ) == 0 )
		exit(0);

	invokeExternal( method, obj, skey, sval );
}


void
Java_java_lang_VMRuntime_insertSystemProperties__Ljava_util_Properties_2
(void *env, jclass cls, jobject obj)
{
        struct utsname info;
        uname(&info);

	setProperty( obj, "java.version", "");
	setProperty( obj, "java.vendor", "");
	setProperty( obj, "java.vendor.url","");
	setProperty( obj, "java.home","");
	setProperty( obj, "java.vm.specification.version","");
	setProperty( obj, "java.vm.specification.vendor","");
	setProperty( obj, "java.vm.specification.name","");
	setProperty( obj, "java.vm.version","");
	setProperty( obj, "java.vm.vendor","");
	setProperty( obj, "java.vm.name","cream");
	setProperty( obj, "java.specifiaction.version","");
	setProperty( obj, "java.specification.vendor","");
	setProperty( obj, "java.specification.name","");
	setProperty( obj, "java.class.version","");
	setProperty( obj, "java.class.path","../lib");
	setProperty( obj, "java.library.path","../lib:./");
	setProperty( obj, "java.io.tmpdir","");
	setProperty( obj, "java.compiler","");
	setProperty( obj, "java.ext.dirs","");
	setProperty( obj, "os.name", info.sysname );
	setProperty( obj, "os.arch", info.machine );
	setProperty( obj, "os.version", info.release );
	setProperty( obj, "file.separator","/");
	setProperty( obj, "path.separator",":");
	setProperty( obj, "line.separator","\n");
	setProperty( obj, "user.name", getenv("USER") );
	setProperty( obj, "user.home", getenv("HOME") );
	setProperty( obj, "user.dir", getenv("PWD") );
	setProperty( obj, "java.system.class.loader", "gnu.java.lang.SystemClassLoader");
	
	return;
}


jstring
Java_java_lang_VMRuntime_nativeGetLibname__Ljava_lang_String_2Ljava_lang_String_2
(void *env, jclass cls, jstring str1, jstring str2)
{
	/* what's str1? */

	type_array* array;
	type_object* result;
	jchar* text;
	int i;
	unsigned char* lib_name;
	unsigned char* file_name;


	array = *(u4*)((type_object*)str2)->ref;
	text = (jchar*)array->ref;
	
	lib_name = malloc( sizeof(u1) * array->length+1 );
	file_name = malloc( sizeof(u1) * array->length+7 );
	
	for( i = 0 ; i < array->length ; i++ )
		lib_name[i] = (char)text[i];
	lib_name[i] = '\0';

	sprintf( file_name, "lib%s.so", lib_name );

	file_name = loadUtf8( file_name );

	result = newString( file_name );

	/* debug */	
	printf( ">>%s %x\n", file_name, result );
	/* debug */

	return (result);
}


jint Java_java_lang_VMRuntime_nativeLoad__Ljava_lang_String_2
(void *env, jobject obj, jstring str)
{
	type_array* array;
	jchar* text;
	jint result;
	int i;
	unsigned char* file_name;


	array = *(u4*)((type_object*)str)->ref;
	text = (jchar*)array->ref;

	file_name = malloc( sizeof(u1) * array->length+1 );	
	
	for( i = 0 ; i < array->length ; i++ )
		file_name[i] = (char)text[i];
	file_name[i] = '\0';

	result = loadNative( file_name );
	
	/* debug */
	printf("loading %s...%x\n", file_name, result );
	/* debug */

	return (result);
}


// ============================================================================
// VM Security Manager
// ============================================================================

jarray Java_java_lang_VMSecurityManager_getClassContext
(void *env, jclass cls)
{
	type_frame* frame = getThreadFrame();
	type_frame* current = frame;
	type_class* class = cload( loadUtf8("java/lang/Class"), 0 );
	type_array* array;
	int depth, i ;

	
	for( depth = 0 ; current->prv != 0 ; depth++, current = current->prv );

	/* debug */
	printf("frame count = %x\n", depth );
	/* debug */

	array = newObjectArray( class, depth );
	current = frame;
	for( i = 0 ; i < depth ; i++, current = current->prv )
		((u4*)array->ref)[i] = ((type_method_table*)current->method)->cls;

	return(array);
}


jobject Java_java_lang_VMSecurityManager_currentClassLoader
(void* env, jclass cls)
{
//	type_loader *loader = getBootLoader();
	return(0);
}

// ============================================================================
// VM System
// ============================================================================


jint Java_java_lang_VMSystem_identityHashCode__Ljava_lang_Object_2
(void *env, jclass cls, jobject obj)
{
	type_object* object = obj;
	int pos;
	int hash;

//	printf( "%x %x \n", cls, obj );

	if( object == 0 || object->cls == 0 )
		exit(0);
	
	hash = (int)obj;

	return (hash);
}


void Java_java_lang_VMSystem_arraycopy__Ljava_lang_Object_2ILjava_lang_Object_2II
(void *env, jclass cls, jobject o1, jint i1, jobject o2, jint i2, jint i3)
{
	copyArray( o1, i1, o2, i2, i3 );
}


// ============================================================================
// VM Thread
// ============================================================================

jobject Java_java_lang_VMThread_currentThread
(void *env, jclass cls)
{
	type_native_thread* native_thread;
	type_object* thread;


	native_thread = getCurrentThread();
	thread = native_thread->thread;

	if( thread == 0 )
	{
		printf("thread is null\n");
		exit(0);
	}

	return (thread);
}
/*
JNIEXPORT void Java_java_lang_VMThread_start__J
(JNIEnv *env, jobject obj, jlong j)
{
	Hjava_lang_Object* vmThread = obj;
	Hjava_lang_Object* thread;
	int pos;

	pos = get_field_position( vmThread->field, "thread" );
	thread = *( vmThread->field->list_ref + pos/4 );

	printf(" {in vmthread, thread starting! : %x}\n", thread );
	jthread_create( thread );
	printf(" {in vmthread, thread started! : %x}\n", thread );	
}
*/
